//--------------------------------------------------------------------
//                                                                    
//  Module:       CardDemo                                       
//  Description:  CardDemo
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class CardDemo extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPCardPanel CardPanel1;
	Label Label1;
	Label Label2;
	Button Button1;
	Button Button2;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		CardPanel1 = new JDPCardPanel();
		Label1 = new Label("Label1", Label.LEFT);
		Label2 = new Label("Label2", Label.LEFT);
		Button1 = new Button("Button1");
		Button2 = new Button("Button2");

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", CardPanel1);
		CardPanel1.add("Label1", Label1);
		CardPanel1.add("Label2", Label2);
		Main.add("West", Button1);
		Main.add("South", Button2);

		CardPanel1.setFont(new Font("Helvetica", Font.PLAIN, 11));
		CardPanel1.setForeground(user.u._cvtcolor("Black"));
		CardPanel1.setBackground(user.u._cvtcolor("LightGray"));


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(Button1)) {
				CardPanel1.setSelectedComp("Label1");
				return true;
			}
			if (e.target.equals(Button2)) {
				CardPanel1.setSelectedComp("Label2");
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}

}

