//--------------------------------------------------------------------
//                                                                    
//  Module:       TreeCardDemo                                       
//  Description:  TreeCardDemo
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class TreeCardDemo extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPChiselFramePanel ChiselPanel1;
	JDPTreePicker TreeStructure1;
	JDPCardPanel CardPanel1;
	SalesOrder SalesOrder1;
	SimpleEmail SimpleEmail1;
	TreePopupMenu TreePopupMenu1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		ChiselPanel1 = new JDPChiselFramePanel(user, "Select the Application");
		TreeStructure1 = new JDPTreePicker(user);
		TreeStructure1.setRoot("My Tree Structure", true);
		CardPanel1 = new JDPCardPanel();
		SalesOrder1 = new SalesOrder();
		SalesOrder1.InitClass(user, targetPanel, moduleParameter);
		SimpleEmail1 = new SimpleEmail();
		SimpleEmail1.InitClass(user, targetPanel, moduleParameter);
		TreePopupMenu1 = new TreePopupMenu();
		TreePopupMenu1.InitClass(user, targetPanel, moduleParameter);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("West", ChiselPanel1);
		ChiselPanel1.add("Center", TreeStructure1);
		Main.add("Center", CardPanel1);
		CardPanel1.add("SalesOrder1", SalesOrder1);
		CardPanel1.add("SimpleEmail1", SimpleEmail1);
		CardPanel1.add("TreePopupMenu1", TreePopupMenu1);



		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(TreeStructure1)) {
				CardPanel1.setSelectedComp(TreeStructure1.getSelectedItem()+"1");
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		int[] icons = {JDPTreePicker.COMPUTER,JDPTreePicker.TABLE};
		String[] entry = {"",null};
		boolean[] expanded = {true,true};
		TreeStructure1.setIcons(icons);
		TreeStructure1.setExpanded(expanded);
		TreeStructure1.setRoot("Example Applications",true);

		String[] names = new String[1];
		names[0] = "SalesOrder";
		TreeStructure1.addEntry(names);
		names[0] = "SimpleEmail";
		TreeStructure1.addEntry(names);
		names[0] = "TreePopupMenu";
		TreeStructure1.addEntry(names);

		TreeStructure1.reDraw();
	}

}

