//--------------------------------------------------------------------
//                                                                    
//  Module:       FilePickerOpen                                       
//  Description:  FilePickerOpen
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class FilePickerOpen extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPFilePicker FilePicker1;
	JDPScrollPanel ScrollPanel1;
	Label Label1;
	TextField TextField1;
	Label Label2;
	TextField TextField2;
	Label Label3;
	TextField TextField3;
	Label Label4;
	TextArea TextArea1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		FilePicker1 = new JDPFilePicker();
		FilePicker1.InitClass(user, targetPanel, moduleParameter);
		ScrollPanel1 = new JDPScrollPanel();
		Label1 = new Label("Selected Directory:", Label.LEFT);
		TextField1 = new TextField("", 40);
		Label2 = new Label("Selected File:", Label.LEFT);
		TextField2 = new TextField("", 40);
		Label3 = new Label("Full Path:", Label.LEFT);
		TextField3 = new TextField("", 40);
		Label4 = new Label("Contents:", Label.LEFT);
		TextArea1 = new TextArea("", 6,60);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", FilePicker1);
		Main.add("North", ScrollPanel1);
		ScrollPanel1.add("Left", Label1);
		ScrollPanel1.add("Right", TextField1);
		ScrollPanel1.add("Left", Label2);
		ScrollPanel1.add("Right", TextField2);
		ScrollPanel1.add("Left", Label3);
		ScrollPanel1.add("Right", TextField3);
		ScrollPanel1.add("Left", Label4);
		ScrollPanel1.add("Right", TextArea1);

		FilePicker1.setSelectedDirectory("\\");
		Label4.setFont(new Font("Helvetica", Font.PLAIN, 11));
		Label4.setForeground(user.u._cvtcolor("Black"));
		Label4.setBackground(user.u._cvtcolor("LightGray"));
		TextArea1.setFont(new Font("Helvetica", Font.PLAIN, 11));
		TextArea1.setForeground(user.u._cvtcolor("Black"));
		TextArea1.setBackground(user.u._cvtcolor("LightGray"));


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(FilePicker1)) {
				String choice = (String)e.arg;
				if (!choice.equals("Cancel")) {
					TextField1.setText(FilePicker1.getSelectedDirectory());
				} else {
					TextField1.setText(choice);
				}
				TextField2.setText(FilePicker1.getSelectedFile());
				TextField3.setText(FilePicker1.getSelectedFullPath());
				TextArea1.setText(user.u.readFromFile(TextField3.getText()));
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}

}

