//--------------------------------------------------------------------
//                                                                    
//  Module:       HtmlLoader                                       
//  Description:  HtmlLoader
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class HtmlLoader extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPList List1;
	JDPScrollPanel ScrollPanel1;
	Label Label1;
	TextField TextField1;
	JDPRichText RichText1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		List1Main();
		ScrollPanel1 = new JDPScrollPanel();
		Label1 = new Label("Selected URL:", Label.LEFT);
		TextField1 = new TextField("", 30);
		RichText1 = new JDPRichText(user);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("West", List1);
		Main.add("Center", ScrollPanel1);
		ScrollPanel1.add("Left", Label1);
		ScrollPanel1.add("Right", TextField1);
		Main.add("South", RichText1);

		RichText1.setFont(new Font("Helvetica", Font.BOLD, 11));
		RichText1.setText("This applet will load the URL into the browser when this applet has been loaded from a browser");


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(List1)) {
				TextField1.setText(List1.getSelectedKey());
				try {
					user.JDesignerPro.getAppletContext().showDocument(new URL(List1.getSelectedKey()));
				} catch (Exception e1) {
				}
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}
	//
	//  Load the elements into the List
	//
	public void List1Main() {

		if (List1 == null) {
			List1 = new JDPList(user);
		} 

		JDPJagg jaggSQL = new JDPJagg(user.jaggPath);
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		List1.loadList(user, jaggSQL, "URLDesc","URL","dbo_URLs","(1=1)");
												 
	}


}

