//--------------------------------------------------------------------
//                                                                    
//  Module:       SimpleMenuControl                                       
//  Description:  SimpleMenuControl
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SimpleMenuControl extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPScrollPanel ScrollPanel1;
	Button Button1;
	Button Button2;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		this.targetPanel = targetPanel;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		ScrollPanel1 = new JDPScrollPanel();
		Button1 = new Button("System Maintenance");
		Button2 = new Button("Simple SQL");

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", ScrollPanel1);
		ScrollPanel1.add("Left", Button1);
		ScrollPanel1.add("Right", Button2);



		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
		//
		//  Initialise Components
		//
		InitComponents();
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(Button1)) {
				JDPTabSelectPanel tab = user.jdpMenuPanel;
				tab.select(-1);
				tab.select("System Maintenance");
				return true;
			}
			if (e.target.equals(Button2)) {
				JDPTabSelectPanel tab = user.jdpMenuPanel;
				tab.select("Examples");
				tab.select("Example Menu3");
				tab.select("Simple SQL");
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	/**
	 * Initialise other components by calling their methods
	 */
	public void InitComponents() {

		jaggSQL.setKeepConnectionOpen(false);

	}


}

