//--------------------------------------------------------------------
//                                                                    
//  Module:       PopupMenu                                       
//  Description:  PopupMenu
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class PopupMenu extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPPopupMenu JDPPopupMenu1;
	JDPScrollPanel ScrollPanel1;
	Label Label1;
	TextField TextField1;
	Panel Panel1;
	Label Label2;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		JDPPopupMenu1 = new JDPPopupMenu(user.getJDPUser(), Main);
		ScrollPanel1 = new JDPScrollPanel();
		Label1 = new Label("Menu Option that was chosen:", Label.LEFT);
		TextField1 = new TextField("", 20);
		Panel1 = new Panel();
		Label2 = new Label("Click anywhere below this label to show menu", Label.LEFT);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("North", JDPPopupMenu1);
		Main.add("Center", ScrollPanel1);
		ScrollPanel1.add("Left", Label1);
		ScrollPanel1.add("Right", TextField1);
		ScrollPanel1.add("Left", Panel1);
		Panel1.setLayout(new BorderLayout());
		ScrollPanel1.add("Left", Label2);



		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(JDPPopupMenu1)) {
				TextField1.setText(JDPPopupMenu1.getSelectedMenu(0));
				return true;
			}
			return false;

		case Event.MOUSE_UP:
			if (e.target.equals(ScrollPanel1)) {
				JDPPopupMenu1.clear();
				JDPPopupMenu1.addEntry("Menu Option 1");
				JDPPopupMenu1.addEntry("Menu Option 2");
				JDPPopupMenu1.addEntry("");
				JDPPopupMenu1.addEntry("Menu Option 3");
				JDPPopupMenu1.display(e.x, e.y);
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}

}

