//--------------------------------------------------------------------
//                                                                    
//  Module:       TreePopupMenu                                       
//  Description:  TreePopupMenu
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class TreePopupMenu extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPPopupMenu PopupMenu1;
	JDPChiselFramePanel ChiselPanel1;
	JDPTreePicker TreeStructure1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		PopupMenu1 = new JDPPopupMenu(user.getJDPUser(), Main);
		ChiselPanel1 = new JDPChiselFramePanel(user, "Tree Structure with Popup Menu Demo");
		TreeStructure1 = new JDPTreePicker(user);
		TreeStructure1.setRoot("My Tree Structure", true);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("West", PopupMenu1);
		Main.add("Center", ChiselPanel1);
		ChiselPanel1.add("Center", TreeStructure1);



		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(PopupMenu1)) {
				String branchName = TreeStructure1.getCurrentBranch().name;
				user.mainmsg.setStatusMsg(PopupMenu1.getSelectedMenu(0) + " on " + branchName + " selected.", 5);
				return true;
			}
			return false;

		case Event.LIST_SELECT:
			if (e.target.equals(TreeStructure1)) {
				PopupMenu1.clear();
				PopupMenu1.addEntry("Send Email...");
				PopupMenu1.addEntry("");
				PopupMenu1.addEntry("Remove");
				PopupMenu1.display(e.x, e.y);
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		int[] icons = {JDPTreePicker.COMPUTER,JDPTreePicker.PERSON};
		String[] entry = {"",null};
		boolean[] expanded = {true,true};
		TreeStructure1.setIcons(icons);
		TreeStructure1.setExpanded(expanded);
		TreeStructure1.setRoot("Employees",true);

		String[] names = new String[1];
		names[0] = "John";
		TreeStructure1.addEntry(names);
		names[0] = "Mary";
		TreeStructure1.addEntry(names);
		names[0] = "Steven";
		TreeStructure1.addEntry(names);
		names[0] = "Joe";
		TreeStructure1.addEntry(names);
		names[0] = "Andrew";
		TreeStructure1.addEntry(names);

		TreeStructure1.reDraw();
	}

}

