//--------------------------------------------------------------------
//                                                                    
//  Module:       HtmlAndExcel                                       
//  Description:  HtmlAndExcel
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class HtmlAndExcel extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPSearchResults ResultList1;
	JDPButtons JDPButtons1;
	JDPEmailSender EMail1;
	Panel Panel1;
	Panel Columns1;
	JDPScrollPanel ScrollPanel1;
	Label stor_idLabel1;
	TextField stor_id1;
	Label stor_nameLabel1;
	TextField stor_name1;
	Label stor_addressLabel1;
	TextField stor_address1;
	Label cityLabel1;
	Panel cityLine1;
	TextField city1;
	TextField state1;
	TextField zip1;
	Panel Panel2;
	Label Label1;
	Label Label2;
	Label Label3;
	Label Label4;
	Label Label5;
	JDPTextGrid DetailGrid1;
	JDPFormatDoc Formatter1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		ResultList1Main();
		String[] JDPButtons1btns = {"Create Html","Create Excel"};
		int[] JDPButtons1icns = {JDPButton.getIconValue("New"),JDPButton.getIconValue("New")};
		JDPButtons1 = new JDPButtons(user, JDPButtons1btns, JDPButtons1icns, JDPButtons.getAlignmentValue("Horizontal"));
		EMail1 = new JDPEmailSender(user);
		Panel1 = new Panel();
		Columns1 = new Panel();
		ScrollPanel1 = new JDPScrollPanel();
		stor_idLabel1 = new Label("Stor Id:", Label.LEFT);
		stor_id1 = new TextField("stor_id", 6);
		stor_nameLabel1 = new Label("Stor name:", Label.LEFT);
		stor_name1 = new TextField("stor_name", 42);
		stor_addressLabel1 = new Label("Stor Address:", Label.LEFT);
		stor_address1 = new TextField("stor_address", 42);
		cityLabel1 = new Label("City:", Label.LEFT);
		cityLine1 = new Panel();
		city1 = new TextField("city", 22);
		state1 = new TextField("state", 4);
		zip1 = new TextField("zip", 7);
		Panel2 = new Panel();
		Label1 = new Label("Label1", Label.LEFT);
		Label2 = new Label("Label2", Label.LEFT);
		Label3 = new Label("Label3", Label.LEFT);
		Label4 = new Label("Label4", Label.LEFT);
		Label5 = new Label("Label5", Label.LEFT);
		DetailGrid1Main();
		Formatter1 = new JDPFormatDoc(user);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("West", ResultList1);
		Main.add("South", JDPButtons1);
		Main.add("Center", Panel1);
		Panel1.setLayout(new BorderLayout());
		Panel1.add("North", Columns1);
		Columns1.setLayout(new BorderLayout());
		Columns1Main();
		Columns1.add("Center", ScrollPanel1);
		ScrollPanel1.add("Left", stor_idLabel1);
		ScrollPanel1.add("Right", stor_id1);
		ScrollPanel1.add("Left", stor_nameLabel1);
		ScrollPanel1.add("Right", stor_name1);
		ScrollPanel1.add("Left", stor_addressLabel1);
		ScrollPanel1.add("Right", stor_address1);
		ScrollPanel1.add("Left", cityLabel1);
		ScrollPanel1.add("Right", cityLine1);
		cityLine1.setLayout(new JDPLineLayout());
		cityLine1.add("Left", city1);
		cityLine1.add("Left", state1);
		cityLine1.add("Left", zip1);
		Panel1.add("South", Panel2);
		Panel2.setLayout(new GridLayout(4,3));
		Panel2.add(Label1);
		Panel2.add(Label2);
		Panel2.add(Label3);
		Panel2.add(Label4);
		Panel2.add(Label5);
		Panel1.add("Center", DetailGrid1);

		popuppanel.addComponent(stor_id1 ,"Stor Id" ,"");
		popuppanel.addComponent(stor_name1 ,"Stor name" ,"");
		popuppanel.addComponent(stor_address1 ,"Stor Address" ,"");
		popuppanel.addComponent(city1 ,"City" ,"");
		popuppanel.addComponent(state1 ,"State" ,"");
		popuppanel.addComponent(zip1 ,"Zip" ,"");
		DetailGrid1.setFont(new Font("Helvetica", Font.PLAIN, 11));
		DetailGrid1.setForeground(user.u._cvtcolor("Black"));
		DetailGrid1.setBackground(user.u._cvtcolor("LightGray"));


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(ResultList1)) {
				DetailGrid1LoadGrid(ResultList1.getSelectedKey());
				Columns1Load(ResultList1.getSelectedKey());
				return true;
			}
			if (e.target.equals(JDPButtons1.button[0])) {
				Formatter1.initDocument(JDPFormatDoc.HTML);
				Formatter1.setTitle("My first html report");
				Formatter1.setBody("");
				Formatter1.addHeader("My First Report", "h2");
				Formatter1.addComponent(Panel1);
				Formatter1.finishOutput();
				Formatter1.loadDocument();
				return true;
			}
			if (e.target.equals(JDPButtons1.button[1])) {
				Formatter1.initDocument(JDPFormatDoc.EXCEL);
				Formatter1.addComponent(DetailGrid1);
				Formatter1.finishOutput();
				Formatter1.loadDocument();
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}
	//
	//  Create and load the Result List Panel
	//
	public void ResultList1Main() {

		String ResultList1sf = "stor_id";
		String[] ResultList1df = {};
		String ResultList1wc = "(1=1)";
		String[] ResultList1sct = {"Stor  name"};
		String[] ResultList1sc = {"stor_name"};
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
		jaggSQL.setJdbcPrefix("jdbc:odbc:");
		jaggSQL.setJdbcSuffix("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR(" ");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");
		ResultList1 = new JDPSearchResults(user, targetPanel, true, jaggSQL, false, ResultList1sf, ResultList1df, ResultList1wc, ResultList1sct, ResultList1sc, ResultList1sc, "", true, "Total Entries:");
		int[] ResultList1icons = new int[3];
		ResultList1icons[0] = 3;
		ResultList1icons[1] = 5;
		ResultList1.setMinWidth(130);
		ResultList1.setIcons(ResultList1icons);
		ResultList1.setFromWhereClause(" FROM dbo_stores WHERE (1=1)");
		ResultList1.clearList("");
		ResultList1.loadList();
	}

	//
	//  Main initialization method
	//
	public void Columns1Main() {

		Columns1LoadChoices();
		Columns1ClearFields();

	}

	//
	//  Load the selected item
	//
	public void Columns1Load(String[] keys) {

		StringTokenizer stok;

		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		String tempText;

		if (keys == null || keys.length < 0) {
			Columns1ClearFields();
			return;
		}

		String SQL = "SELECT stor_id," +
					"stor_name," +
					"stor_address," +
					"city," +
					"state," +
					"zip" +
					" FROM dbo_stores" +
					" WHERE (1=1)";
		if (keys.length > 0 && keys[0] != null) SQL += " AND stor_id='" + keys[0]+ "'" ;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
		jaggSQL.setJdbcPrefix("jdbc:odbc:");
		jaggSQL.setJdbcSuffix("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		user.mainmsg.setStatusMsg("Accessing database...", 0);
		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}
		if(recCount >= 1) {
			row = (String)results.elementAt(0);
			if ((row != null) && (row.trim().compareTo("") != 0)) {
				stok = new StringTokenizer(row);
				stor_id1.setText(stok.nextToken(sep).trim());
				stor_name1.setText(stok.nextToken(sep).trim());
				stor_address1.setText(stok.nextToken(sep).trim());
				city1.setText(stok.nextToken(sep).trim());
				state1.setText(stok.nextToken(sep).trim());
				zip1.setText(stok.nextToken(sep).trim());
			}
			if(recCount > 1) {
				user.mainmsg.setStatusMsg("Multiple records found - first match only displayed.", 10);
			} else {
				user.mainmsg.clearStatusMsg();
			}
		} else {
			user.mainmsg.setStatusMsg("Requested entry does not exist.", 10);
			Columns1ClearFields();
		}

	}

	//
	//  Update the selected item
	//
	public boolean Columns1updateRow(String[] keys) {

		if (Columns1CheckFields()) {
			return Columns1Save(keys, "U");
		}
		return false;
	}

	//
	//  Insert the selected item
	//
	public boolean Columns1insertRow(String[] keys) {

		if (Columns1CheckFields()) {
			return Columns1Save(keys, "I");
		}
		return false;
	}

	//
	//  Remove the selected item
	//
	public boolean Columns1removeRow(String[] keys) {

		return Columns1Save(keys, "D");
	}

	//
	//  Save the selected item
	//
	boolean Columns1Save(String[] keys, String action) {

		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		String SQL = "";

		if (action.equals("I")) {
			SQL = "INSERT INTO dbo_stores (stor_id, " +
					"stor_name, " +
					"stor_address, " +
					"city, " +
					"state, " +
					"zip) VALUES('" + user.u.replace(stor_id1.getText(),"'","''") + "', " +
					"'" + user.u.replace(stor_name1.getText(),"'","''") + "', " +
					"'" + user.u.replace(stor_address1.getText(),"'","''") + "', " +
					"'" + user.u.replace(city1.getText(),"'","''") + "', " +
					"'" + user.u.replace(state1.getText(),"'","''") + "', " +
					"'" + user.u.replace(zip1.getText(),"'","''") + "')";
		} else {
			if (keys == null || keys.length == 0) {
				user.mainmsg.setStatusMsg("You must first make a selection",5);
				return false;
			}
			if (action.equals("D")) {
				SQL = "DELETE FROM dbo_stores" +
					" WHERE stor_id='" + keys[0]+ "'" ;
			} else {
				SQL = "UPDATE dbo_stores SET stor_name = '" + user.u.replace(stor_name1.getText(),"'","''") + "', " +
					"stor_address = '" + user.u.replace(stor_address1.getText(),"'","''") + "', " +
					"city = '" + user.u.replace(city1.getText(),"'","''") + "', " +
					"state = '" + user.u.replace(state1.getText(),"'","''") + "', " +
					"zip = '" + user.u.replace(zip1.getText(),"'","''") + "'" +
					" WHERE stor_id='" + keys[0]+ "'" ;
			}
		}

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
		jaggSQL.setJdbcPrefix("jdbc:odbc:");
		jaggSQL.setJdbcSuffix("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		user.mainmsg.setStatusMsg("Accessing database...", 0);
		recCount = jaggSQL.execSQL(SQL, results);

		if (recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return false;
		}
		if (recCount == 1) {
			if (action.equals("I")) {
				user.mainmsg.setStatusMsg("Record successfully added.",3);
			} else 
			if (action.equals("D")) {
				user.mainmsg.setStatusMsg("Record successfully removed.",3);
			} else {
				user.mainmsg.setStatusMsg("Record successfully updated.",3);
			}
		} else {
			user.u.setSqlMessage(jaggSQL,SQL);
		}
		return true;

	}

	//
	//  Clear the screen fields for a new option
	//
	public void Columns1ClearFields() {

		stor_id1.setText("");
		stor_name1.setText("");
		stor_address1.setText("");
		city1.setText("");
		state1.setText("");
		zip1.setText("");

	}

	//
	//  Load all of the Screen Choices
	//
	void Columns1LoadChoices() {

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
		jaggSQL.setJdbcPrefix("jdbc:odbc:");
		jaggSQL.setJdbcSuffix("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

	}

	//
	//  Perform component validations
	//
	public boolean Columns1CheckFields() {


		return true;

	}

	//
	//  Main initialization method
	//
	public void DetailGrid1Main() {

		DetailGrid1SetGridSettings();

	}


	//
	//  Load the grid with the specified parameters and selected data
	//
	public void DetailGrid1LoadGrid(String[] keys) {

		DetailGrid1LoadGridMain(keys, null);
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	public void DetailGrid1UpdateRows(String[] keys) {

		JDPTextGrid tableContents = DetailGrid1;

		if (keys == null || keys.length < 0) {
			DetailGrid1LoadEmptyGrid();
			return;
		}

		int changedCount = 0;
		int insertedCount = 0;
		int cCount = 1;
		int iCount = 1;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					insertedCount++;
				} else {
					changedCount++;
				}
			}
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					user.mainmsg.setStatusMsg("Inserting row " + Integer.toString(iCount++) + " of " + Integer.toString(insertedCount) + "...", 0);
					DetailGrid1SaveData(ix,"I");
				} else {
					user.mainmsg.setStatusMsg("Updating row " + Integer.toString(cCount++) + " of " + Integer.toString(changedCount) + "...", 0);
					DetailGrid1SaveData(ix,"U");
				}
				tableContents.rowChanged[ix] = false;
			}
		}
		if (insertedCount > 0) {
			DetailGrid1LoadGrid(keys);
		}
	}


	//
	//  Delete any of the selected rows
	//
	public void DetailGrid1DeleteRows(String[] keys) {

		JDPTextGrid tableContents = DetailGrid1;

		if (keys == null || keys.length < 0) {
			DetailGrid1LoadEmptyGrid();
			return;
		}

		int deletedCount = 0;
		int cCount = 1;
		int iCount = 1;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				deletedCount++;
			} 
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				user.mainmsg.setStatusMsg("Deleting row " + Integer.toString(iCount++) + " of " + Integer.toString(deletedCount) + "...", 0);
				DetailGrid1SaveData(ix,"D");
			}
		}
		if (deletedCount > 0) {
			DetailGrid1LoadGrid(keys);
		}
	}


	//
	//  Save the selected item
	//
	boolean DetailGrid1SaveData(int tableRow, String action) {

		JDPTextGrid tableContents = DetailGrid1;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		String SQL = "";
		String prevSQL = null;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		if (action.equals("I")) {
			SQL = "INSERT INTO dbo_sales (stor_id, " +
					"ord_num, " +
					"ord_date, " +
					"qty, " +
					"payterms, " +
					"title_id) VALUES('" + user.u.replace(tableContents.currentText[0][tableRow],"'","''") + "', " +
					"'" + user.u.replace(tableContents.currentText[1][tableRow],"'","''") + "', " +
					"'" + JDPDate.format(tableContents.currentText[2][tableRow]) + "', " +
					"" + JDPUtils.tonum(tableContents.currentText[3][tableRow]) + ", " +
					"'" + user.u.replace(tableContents.currentText[4][tableRow],"'","''") + "', " +
					"'" + user.u.replace(tableContents.currentText[5][tableRow],"'","''") + "')";
		} else {
			if (action.equals("D")) {
				SQL = "DELETE FROM dbo_sales" +
					" WHERE stor_id='" + tableContents.rowKey[tableRow][0]+ "'" ;
				if (tableContents.recordLockValue[tableRow] != null) {
					prevSQL = SQL;
				}
			} else {
				SQL = "UPDATE dbo_sales SET ord_num = '" + user.u.replace(tableContents.currentText[1][tableRow],"'","''") + "', " +
					"ord_date = '" + JDPDate.format(tableContents.currentText[2][tableRow]) + "', " +
					"qty = " + JDPUtils.tonum(tableContents.currentText[3][tableRow]) + ", " +
					"payterms = '" + user.u.replace(tableContents.currentText[4][tableRow],"'","''") + "', " +
					"title_id = '" + user.u.replace(tableContents.currentText[5][tableRow],"'","''") + "'" +
					" WHERE stor_id='" + tableContents.rowKey[tableRow][0]+ "'" ;
				if (tableContents.recordLockValue[tableRow] != null) {
					prevSQL = SQL;
				}
			}
		}

		recCount = jaggSQL.execSQL(SQL, results);

		if (user.DEBUG) System.out.println("saveData CNT: "+Integer.toString(recCount));

		if (recCount == 0 && prevSQL != null) {
			String[] buttons = {"Reload","Update"};
			int[] icons = {JDPButton.UNDO,JDPButton.SAVE};
			JDPMessageDialog d = new JDPMessageDialog(user, user.jdpMainWindow, JDPLang.get("Dialog0"), JDPLang.get("Dialog1"), buttons, icons);
			d.display();
			if (d.getPressedButton() == 1) {
				results = new Vector();
				recCount = jaggSQL.execSQL(prevSQL, results);
			} else {
				return true;
			}
		}

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return false;
		}
		if(recCount == 1) {
			if (action.equals("I")) {
				user.mainmsg.setStatusMsg(JDPLang.get("Message4"),3);
			} else 
			if (action.equals("D")) {
				user.mainmsg.setStatusMsg(JDPLang.get("Message5"),3);
			} else {
				user.mainmsg.setStatusMsg(JDPLang.get("Message6"),3);
			}
		} else {
			user.u.setSqlMessage(jaggSQL,SQL);
		}
		if (prevSQL != null) {
			return true;
		}
		return false;

	}


	//
	//  Load the grid with the blank rows to allow data entry
	//
	public void DetailGrid1LoadEmptyGrid() {

		JDPTextGrid tableContents = DetailGrid1;
		int columnCount = 6;

		tableContents.currentText = new String[columnCount][50];
		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		tableContents.rowKey = new String[50][1];
		tableContents.newTable();
		tableContents.totalDataRows = 0;
	}


	//
	//  Set up the parameters for this grid
	//
	void DetailGrid1SetGridSettings() {

		if (DetailGrid1 == null) {
			DetailGrid1 = new JDPTextGrid(user);
		} 
		JDPTextGrid tableContents = DetailGrid1;
		int columnCount = 6;

		tableContents.columnHeader = new String[columnCount];
		tableContents.columnHeaderStyle = new int[columnCount];
		tableContents.columnStyle = new int[columnCount];
		tableContents.columnHeaderColor = new Color[columnCount];
		tableContents.columnColor = new Color[columnCount];
		tableContents.columnBGColor = new Color[columnCount];
		tableContents.columnProtected = new boolean[columnCount];
		tableContents.columnWidth = new int[columnCount];
		tableContents.rightJustify = new boolean[columnCount];
		tableContents.rowHeader = null;
		tableContents.columnHeight = null;
		for (int ix=0; ix<columnCount; ix++) {
			tableContents.columnHeaderStyle[ix] = Font.BOLD;
			tableContents.columnStyle[ix] = Font.PLAIN;
			tableContents.columnHeaderColor[ix] = Color.black;
			tableContents.columnColor[ix] = Color.black;
			tableContents.columnBGColor[ix] = Color.white;
			tableContents.columnStyle[ix] = Font.PLAIN;
		}
		tableContents.columnWidth[0] = 46;
		tableContents.columnWidth[1] = 150;
		tableContents.columnWidth[2] = 126;
		tableContents.columnWidth[3] = 32;
		tableContents.columnWidth[4] = 98;
		tableContents.columnWidth[5] = 56;
		tableContents.rightJustify[3] = true;
		tableContents.columnHeader[0] = "Stor Id";
		tableContents.columnHeader[1] = "Ord Num";
		tableContents.columnHeader[2] = "Ord Date";
		tableContents.columnHeader[3] = "Qty";
		tableContents.columnHeader[4] = "Payterms";
		tableContents.columnHeader[5] = "Title Id";

		DetailGrid1LoadEmptyGrid();
		DetailGrid1LoadChoices();
	}


	//
	//  Load all of the Screen Choices
	//
	void DetailGrid1LoadChoices() {

		JDPTextGrid tableContents = DetailGrid1;
		int columnCount = 6;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		tableContents.isPullDownCol = new boolean[columnCount];
		tableContents.pullDownColType = new int[columnCount];
		tableContents.pullDownList = new List[columnCount][1];
	}


	//
	//  Load the grid with the specified parameters and selected data
	//
	public void DetailGrid1LoadGridFromWhereClause(String whereClause) {

		int fPos = whereClause.indexOf("WHERE ");
		whereClause = " AND" + whereClause.substring(fPos+5);
		String[] keys = new String[0];

		DetailGrid1LoadGridMain(keys, whereClause);
	}


	//
	//  Load the grid with the specified parameters and selected data
	//
	void DetailGrid1LoadGridMain(String[] keys, String whereClause) {

		JDPTextGrid tableContents = DetailGrid1;

		StringTokenizer stok;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		int columnCount = 6;

		Vector columns = new Vector();
		Vector indexes = new Vector();

		String SQL = "SELECT stor_id, " +
					"stor_id, " +
					"ord_num, " +
					"format(ord_date, 'mm/dd/yy'), " +
					"qty, " +
					"payterms, " +
					"title_id FROM dbo_sales WHERE (1=1)  ";
		if (keys.length > 0 && keys[0] != null) SQL += " AND stor_id='" + keys[0]+ "'" ;
		if (whereClause != null) {
			SQL += whereClause;
		}

		user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}

		//
		//  Initialise result arrays
		//
		tableContents.totalDataRows = jaggSQL.getRowCount();
		actualRows = jaggSQL.getRowCount()+20;
		tableContents.currentText = new String[columnCount][actualRows];

		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		int keyCount = 1;
		tableContents.rowKey = new String[actualRows][keyCount];
		tableContents.recordLockValue = new String[actualRows];
		
		//
		//  Load key array and grid array
		//
		String tempText;
		for (int ix=0; ix<actualRows-20; ix++) {
			row = (String)results.elementAt(ix);
			if ((row != null) && (row.trim().compareTo("") != 0)) {
				stok = new StringTokenizer(row,sep);
				for (int iy=0; iy<keyCount; iy++) {
					tableContents.rowKey[ix][iy] = stok.nextToken().trim();
				}
				for (int iy=0; iy<columnCount; iy++) {
					tempText = stok.nextToken().trim();
					tableContents.currentText[iy][ix] = tempText;
				}
			}
		}
		for (int ix=actualRows-20; ix<actualRows; ix++) {
			for (int iy=0; iy<keys.length; iy++) {
				tableContents.rowKey[ix][iy] = keys[iy];
			}
		}

		tableContents.newTable();

		//
		//  Clear status message
		//
		user.mainmsg.clearStatusMsg();
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	public void DetailGrid1UpdateRowsFromWhereClause(String whereClause) {

		int fPos = whereClause.indexOf("WHERE ");
		whereClause = " AND" + whereClause.substring(fPos+5);
		String[] keys = new String[0];

		DetailGrid1UpdateRowsMain(keys, whereClause);
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	void DetailGrid1UpdateRowsMain(String[] keys, String whereClause) {

		JDPTextGrid tableContents = DetailGrid1;

		int changedCount = 0;
		int insertedCount = 0;
		int cCount = 1;
		int iCount = 1;
		boolean reload = false;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					insertedCount++;
				} else {
					changedCount++;
				}
			}
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					user.mainmsg.setStatusMsg(JDPLang.get("Message7",iCount++,insertedCount), 0);
					DetailGrid1SaveData(ix,"I");
				} else {
					user.mainmsg.setStatusMsg(JDPLang.get("Message8",cCount++,changedCount), 0);
					if (DetailGrid1SaveData(ix,"U")) {
						reload = true;
					}
				}
				tableContents.rowChanged[ix] = false;
			}
		}
		if (insertedCount > 0 || reload) {
			DetailGrid1LoadGridMain(keys, whereClause);
		}
	}


	//
	//  Delete any of the selected rows
	//
	public void DetailGrid1DeleteRowsFromWhereClause(String whereClause) {

	int fPos = whereClause.indexOf("WHERE ");
		whereClause = " AND" + whereClause.substring(fPos+5);
		String[] keys = new String[0];

		DetailGrid1DeleteRowsMain(keys, whereClause);
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	void DetailGrid1DeleteRowsMain(String[] keys, String whereClause) {

		JDPTextGrid tableContents = DetailGrid1;

		int deletedCount = 0;
		int cCount = 1;
		int iCount = 1;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				deletedCount++;
			} 
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				user.mainmsg.setStatusMsg(JDPLang.get("Message9",iCount++,deletedCount), 0);
				DetailGrid1SaveData(ix,"D");
			}
		}
		if (deletedCount > 0) {
			DetailGrid1LoadGridMain(keys, whereClause);
		}
	}



}

