//--------------------------------------------------------------------
//                                                                    
//  Module:       SimplePrinting                                       
//  Description:  SimplePrinting
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SimplePrinting extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPButtons JDPButtons1;
	JDPScrollPanel ScrollPanel1;
	Label Label1;
	TextField TextField1;
	Label Label2;
	TextField TextField2;
	JDPEmailSender EMail1;
	JDPFormatDoc Formatter1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		CheckboxGroup cbGroup4 = new CheckboxGroup();
		Main = new Panel();
		String[] JDPButtons1btns = {"Create Html","Create Excel","Send Email"};
		int[] JDPButtons1icns = {JDPButton.getIconValue("New"),JDPButton.getIconValue("New"),JDPButton.getIconValue("Email")};
		JDPButtons1 = new JDPButtons(user, JDPButtons1btns, JDPButtons1icns, JDPButtons.getAlignmentValue("Horizontal"));
		ScrollPanel1 = new JDPScrollPanel();
		Label1 = new Label("Name:", Label.LEFT);
		TextField1 = new TextField("", 20);
		Label2 = new Label("Email:", Label.LEFT);
		TextField2 = new TextField("", 20);
		EMail1 = new JDPEmailSender(user);
		Formatter1 = new JDPFormatDoc(user);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("South", JDPButtons1);
		Main.add("Center", ScrollPanel1);
		ScrollPanel1.add("Left", Label1);
		ScrollPanel1.add("Right", TextField1);
		ScrollPanel1.add("Left", Label2);
		ScrollPanel1.add("Right", TextField2);



		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(JDPButtons1.button[0])) {
				Formatter1.initDocument(JDPFormatDoc.HTML);
				Formatter1.setTitle("My first html report");
				Formatter1.setBody("");
				Formatter1.addHeader("My First Report", "h2");
				Formatter1.addComponent(ScrollPanel1);
				Formatter1.finishOutput();
				Formatter1.loadDocument();
				return true;
			}
			if (e.target.equals(JDPButtons1.button[1])) {
				Formatter1.initDocument(JDPFormatDoc.EXCEL);
				Formatter1.addComponent(ScrollPanel1);
				Formatter1.finishOutput();
				Formatter1.loadDocument();
				return true;
			}
			if (e.target.equals(JDPButtons1.button[2])) {
				Formatter1.initDocument(JDPFormatDoc.PLAIN);
				Formatter1.addComponent(ScrollPanel1);
				Formatter1.finishOutput();
				user.u.writeToFile(user.JDesignerPro.JDPDirectory + "temp" + user.JDesignerPro.serverSeparator + user.cust.getUsername() + ".txt", Formatter1.getFinishedDocument(), "w+");
				EMail1.setMailServer("mail");
				EMail1.setToAddress(TextField2.getText());
				EMail1.setReturnAddress(TextField2.getText());
				EMail1.setMessageSubject("Attached file example from JDesignerPro");
				EMail1.setMessage("Hi " + TextField1.getText() + ",\n" + "This message was sent from JDesignerPro to demonstrate how to send an attachment created from the contents of a JDP screen.\n\n");
				EMail1.setAttachment(user.JDesignerPro.JDPDirectory + "temp" + user.JDesignerPro.serverSeparator + user.cust.getUsername() + ".txt");
				EMail1.sendSingleMessage();
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}

}

