//--------------------------------------------------------------------
//                                                                    
//  Module:       SalesReport                                       
//  Description:  SalesReport
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SalesReport extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPSearchResults ResultList1;
	JDPTextGrid ReportLayout1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		CheckboxGroup cbGroup4 = new CheckboxGroup();
		Main = new Panel();
		ResultList1Main();
		ReportLayout1Main();

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("West", ResultList1);
		Main.add("Center", ReportLayout1);



		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(ResultList1)) {
				ReportLayout1LoadGrid(ResultList1.getSelectedKey());
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}
	//
	//  Create and load the Result List Panel
	//
	public void ResultList1Main() {

		String ResultList1sf = "stor_id";
		String[] ResultList1df = {};
		String ResultList1wc = "(1=1)";
		String[] ResultList1sct = {"Stor name"};
		String[] ResultList1sc = {"stor_name"};
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
		jaggSQL.setJdbcPrefix("jdbc:odbc:");
		jaggSQL.setJdbcSuffix("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR(" ");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");
		ResultList1 = new JDPSearchResults(user, targetPanel, true, jaggSQL, false, ResultList1sf, ResultList1df, ResultList1wc, ResultList1sct, ResultList1sc, ResultList1sc, "", true, "Total Entries:");
		int[] ResultList1icons = new int[8];
		ResultList1icons[0] = 3;
		ResultList1icons[1] = 5;
		ResultList1.setMinWidth(130);
		ResultList1.setIcons(ResultList1icons);
		ResultList1.setFromWhereClause(" FROM dbo_stores WHERE (1=1)");
		ResultList1.clearList("");
		ResultList1.loadList();
	}

	//
	//  Main initialization method
	//
	public void ReportLayout1Main() {

		ReportLayout1SetGridSettings();

	}

	//
	//  Load the grid with the specified parameters and selected data
	//
	public void ReportLayout1LoadGrid(String[] keys) {

		JDPTextGrid tableContents = ReportLayout1;

		if (keys == null || keys.length < 0) {
			ReportLayout1LoadEmptyGrid();
			return;
		}

		StringTokenizer stok;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		float[][] worksubTotal;
		float[][] workgrandTotal;
		int columnCount = 6;
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setJdbcDriver("sun.jdbc.odbc.JdbcOdbcDriver");
		jaggSQL.setJdbcPrefix("jdbc:odbc:");
		jaggSQL.setJdbcSuffix("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setCSTR("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");


		Vector columns = new Vector();
		Vector indexes = new Vector();

		String SQL = "SELECT stor_id, " +
					"ord_num, " +
					"format(ord_date, 'mm/dd/yy'), " +
					"title_id, " +
					"qty, " +
					"payterms FROM dbo_sales WHERE (1=1)  ";
		if (keys.length > 0 && keys[0] != null) SQL += " AND stor_id='" + keys[0]+ "'"  +
							" ORDER BY stor_id,ord_num";

		user.mainmsg.setStatusMsg("Accessing database...", 0);

		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}

		//
		//  Initialise result arrays
		//
		actualRows = jaggSQL.getRowCount();
		tableContents.currentText = new String[columnCount][actualRows+30];
		tableContents.cellFont = new Font[columnCount][actualRows+30];
		tableContents.gridColor = Color.white;
		boolean[] totalThisColumn = new boolean[columnCount];
		
		String[] lastItem = new String[columnCount];
		boolean[] subTotal = new boolean[6];
		boolean[] grandTotal = new boolean[6];
		int orderBy = 2;
		subTotal[1] = true;
		grandTotal[0] = true;
		totalThisColumn[4] = true;
		//
		//  Load arrays and result List
		//
		worksubTotal = new float[1][1];
		workgrandTotal = new float[1][1];
		int xOffset = 0;
		int	xIncrement = 0;
		int titlePos = (int)(columnCount/2)-1;
		if (titlePos < 0) titlePos = 0;
		tableContents.currentText[titlePos][1] = "Sales by Store";
		tableContents.cellFont[titlePos][1] = new Font(user.plainFont.getName(),Font.BOLD,user.plainFont.getSize()+4);
		for (int iy=0; iy<columnCount; iy++) {
			tableContents.cellFont[iy][3] = user.boldFont;
		}
		tableContents.currentText[0][3] = "Stor Id";
		tableContents.currentText[1][3] = "Ord Num";
		tableContents.currentText[2][3] = "Ord Date";
		tableContents.currentText[3][3] = "Title Id";
		tableContents.currentText[4][3] = "Qty";
		tableContents.currentText[5][3] = "Payterms";
		xOffset = 4;
		worksubTotal = new float[orderBy][columnCount];
		workgrandTotal = new float[orderBy][columnCount];
		int ix;
		for (ix=0; ix<actualRows; ix++) {
			row = (String)results.elementAt(ix);
			if ((row != null) && (row.trim().compareTo("") != 0)) {
				stok = new StringTokenizer(row);
				for (int iy=0; iy<columnCount; iy++) {
					tableContents.currentText[iy][ix+xOffset] = stok.nextToken(sep).trim();
					if (tableContents.maskEdit[iy] != null) {
						if (tableContents.maskType[iy] == "Float") {
							tableContents.currentText[iy][ix+xOffset] = JDPMaskEditMain.formatFloat(tableContents.currentText[iy][ix+xOffset],tableContents.maskEdit[iy]);
						} else {
							tableContents.currentText[iy][ix+xOffset] = JDPMaskEditMain.formatString(tableContents.currentText[iy][ix+xOffset],tableContents.maskEdit[iy]);
						}
					}
				}
				for (int iy=columnCount-1; iy>=0; iy--) {
					String thisItem = tableContents.currentText[iy][ix+xOffset];
					if ((orderBy > iy) && (ix > 0)) {
						if (thisItem.equals(lastItem[iy])) {
							tableContents.currentText[iy][ix+xOffset] = "";
						} else {
							if (subTotal[iy]) {
								for (int iz=0; iz<columnCount; iz++) {
									tableContents.currentText[iz][ix+xOffset+1] = tableContents.currentText[iz][ix+xOffset];
									tableContents.currentText[iz][ix+xOffset] = "";
									tableContents.cellFont[iz][ix+xOffset+1] = tableContents.cellFont[iz][ix+xOffset];
									tableContents.cellFont[iz][ix+xOffset] = null;
								}
								tableContents.currentText[iy][ix+xOffset] = "Subtotal";
								tableContents.cellFont[iy][ix+xOffset] = user.boldFont;
								for (int iw=iy+1; iw<columnCount; iw++) {
									if (totalThisColumn[iw]) {
										tableContents.currentText[iw][ix+xOffset] = JDPMaskEditMain.formatFloat(worksubTotal[iy][iw],tableContents.maskEdit[iw]);
										tableContents.cellFont[iw][ix+xOffset] = user.boldFont;
									}
									worksubTotal[iy][iw] = 0;
								}
								xOffset += 1;
							}
							tableContents.currentText[iy][ix+xOffset] = thisItem;
						}
					}
					if ((orderBy > 0) && (ix > 0)) {
						try {
							float tempfloat = Float.valueOf(JDPMaskEditMain.stripFloat(lastItem[iy])).floatValue();
							for (int iz=0; iz<orderBy; iz++) {
								worksubTotal[iz][iy] += tempfloat;
								workgrandTotal[iz][iy] += tempfloat;
							}
						} catch(Exception e) { 
						}
					}
					lastItem[iy] = thisItem;
				}
			}
		}

		for (int iy=0; iy<columnCount; iy++) {
			try {
				float tempfloat = Float.valueOf(JDPMaskEditMain.stripFloat(lastItem[iy])).floatValue();
				for (int iz=0; iz<orderBy; iz++) {
					worksubTotal[iz][iy] += tempfloat;
					workgrandTotal[iz][iy] += tempfloat;
				}
			} catch(Exception e) { 
			}
		}
		for (int iy=columnCount-1; iy>=0; iy--) {
			if (orderBy > iy) {
				if (subTotal[iy]) {
					tableContents.currentText[iy][ix+xOffset] = "Subtotal";
					tableContents.cellFont[iy][ix+xOffset] = user.boldFont;
					for (int iw=iy+1; iw<columnCount; iw++) {
						if (totalThisColumn[iw]) {
							tableContents.currentText[iw][ix+xOffset] = JDPMaskEditMain.formatFloat(worksubTotal[iy][iw],tableContents.maskEdit[iw]);
							tableContents.cellFont[iw][ix+xOffset] = user.boldFont;
						}
					}
					xOffset += 1;
				}
			}
		}
		for (int iy=columnCount-1; iy>=0; iy--) {
			if (orderBy > iy) {
				if (grandTotal[iy]) {
					tableContents.currentText[iy][ix+xOffset] = "Total";
					tableContents.cellFont[iy][ix+xOffset] = user.boldFont;
					for (int iw=iy+1; iw<columnCount; iw++) {
						if (totalThisColumn[iw]) {
							tableContents.currentText[iw][ix+xOffset] = JDPMaskEditMain.formatFloat(workgrandTotal[iy][iw],tableContents.maskEdit[iw]);
							tableContents.cellFont[iw][ix+xOffset] = user.boldFont;
						}
					}
					xOffset++;
				}
			}
		}

		tableContents.newTable();

		//
		//  Clear status message
		//
		user.mainmsg.clearStatusMsg();
	}

	//
	//  Load the grid with the blank rows to allow data entry
	//
	public void ReportLayout1LoadEmptyGrid() {

		JDPTextGrid tableContents = ReportLayout1;
		int columnCount = 6;

		tableContents.currentText = new String[columnCount][50];
		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		tableContents.rowKey = new String[50][1];
		tableContents.newTable();
		tableContents.totalDataRows = 0;
	}

	//
	//  Set up the parameters for this grid
	//
	void ReportLayout1SetGridSettings() {

		if (ReportLayout1 == null) {
			ReportLayout1 = new JDPTextGrid(user);
		} 
		JDPTextGrid tableContents = ReportLayout1;
		int columnCount = 6;

		tableContents.columnHeader = null;
		tableContents.columnHeaderStyle = new int[columnCount];
		tableContents.columnStyle = new int[columnCount];
		tableContents.columnHeaderColor = new Color[columnCount];
		tableContents.columnColor = new Color[columnCount];
		tableContents.columnBGColor = new Color[columnCount];
		tableContents.columnProtected = new boolean[columnCount];
		tableContents.columnWidth = new int[columnCount];
		tableContents.rightJustify = new boolean[columnCount];
		tableContents.rowHeader = null;
		tableContents.columnHeight = null;
		tableContents.maskEdit = new String[columnCount];
		tableContents.maskType = new String[columnCount];
		for (int ix=0; ix<columnCount; ix++) {
			tableContents.columnHeaderStyle[ix] = Font.BOLD;
			tableContents.columnStyle[ix] = Font.PLAIN;
			tableContents.columnHeaderColor[ix] = Color.black;
			tableContents.columnColor[ix] = Color.black;
			tableContents.columnBGColor[ix] = Color.white;
			tableContents.columnStyle[ix] = Font.PLAIN;
		}
		tableContents.columnProtected[0] = true;
		tableContents.columnProtected[1] = true;
		tableContents.columnProtected[2] = true;
		tableContents.columnProtected[3] = true;
		tableContents.columnProtected[4] = true;
		tableContents.columnProtected[5] = true;
		tableContents.columnWidth[0] = 46;
		tableContents.columnWidth[1] = 80;
		tableContents.columnWidth[2] = 81;
		tableContents.columnWidth[3] = 56;
		tableContents.columnWidth[4] = 55;
		tableContents.columnWidth[5] = 98;
		tableContents.rightJustify[4] = true;
		tableContents.maskEdit[4] = "999,999,999,999";
		tableContents.maskType[4] = "Float";
		
		ReportLayout1LoadEmptyGrid();
	}


}

