//--------------------------------------------------------------------
//                                                                    
//  Module:       LoadGridPrice                                       
//  Description:  LoadGridPrice
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class LoadGridPrice extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPTextGrid DetailGrid1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		CheckboxGroup cbGroup4 = new CheckboxGroup();
		Main = new Panel();
		DetailGrid1Main();

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", DetailGrid1);



		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.LOST_FOCUS:
			if (e.target.equals(DetailGrid1)) {
				DetailGrid1FetchPrice();
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}
	//
	//  Main initialization method
	//
	public void DetailGrid1Main() {

		DetailGrid1SetGridSettings();

	}

	//
	//  Load the grid with the specified parameters and selected data
	//
	public void DetailGrid1LoadGrid(String[] keys) {

		JDPTextGrid tableContents = DetailGrid1;

		if (keys == null || keys.length < 0) {
			DetailGrid1LoadEmptyGrid();
			return;
		}

		StringTokenizer stok;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		int columnCount = 3;

		Vector columns = new Vector();
		Vector indexes = new Vector();

		String SQL = "SELECT title_id, " +
					"title_id, " +
					"title, " +
					"price FROM dbo_titles WHERE (1=1)  ";
		if (keys.length > 0 && keys[0] != null) SQL += " AND title_id='" + keys[0]+ "'" ;

		user.mainmsg.setStatusMsg("Accessing database...", 0);

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}

		//
		//  Initialise result arrays
		//
		tableContents.totalDataRows = jaggSQL.getRowCount();
		actualRows = jaggSQL.getRowCount()+20;
		tableContents.currentText = new String[columnCount][actualRows];

		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		int keyCount = 1;
		tableContents.rowKey = new String[actualRows][keyCount];
		tableContents.recordLockValue = new String[actualRows];
		
		//
		//  Load key array and grid array
		//
		String tempText;
		for (int ix=0; ix<actualRows-20; ix++) {
			row = (String)results.elementAt(ix);
			if ((row != null) && (row.trim().compareTo("") != 0)) {
				stok = new StringTokenizer(row);
				for (int iy=0; iy<keyCount; iy++) {
					tableContents.rowKey[ix][iy] = stok.nextToken(sep).trim();
				}
				for (int iy=0; iy<columnCount; iy++) {
					tempText = stok.nextToken(sep).trim();
					tableContents.currentText[iy][ix] = tempText;
					if ((iy == 1) && (tableContents.pullDownValue[1][0].indexOf(tempText) >= 0)) tableContents.currentText[iy][ix] = tableContents.pullDownList[1][0].getItem(tableContents.pullDownValue[1][0].indexOf(tempText));
				}
			}
		}
		for (int ix=actualRows-20; ix<actualRows; ix++) {
			for (int iy=0; iy<keys.length; iy++) {
				tableContents.rowKey[ix][iy] = keys[iy];
			}
		}

		tableContents.newTable();

		//
		//  Clear status message
		//
		user.mainmsg.clearStatusMsg();
	}

	//
	//  Check each row that has changed and issue an update to the database
	//
	public void DetailGrid1UpdateRows(String[] keys) {

		JDPTextGrid tableContents = DetailGrid1;

		if (keys == null || keys.length < 0) {
			DetailGrid1LoadEmptyGrid();
			return;
		}

		int changedCount = 0;
		int insertedCount = 0;
		int cCount = 1;
		int iCount = 1;
		boolean reload = false;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					insertedCount++;
				} else {
					changedCount++;
				}
			}
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					user.mainmsg.setStatusMsg("Inserting row " + Integer.toString(iCount++) + " of " + Integer.toString(insertedCount) + "...", 0);
					DetailGrid1SaveData(ix,"I");
				} else {
					user.mainmsg.setStatusMsg("Updating row " + Integer.toString(cCount++) + " of " + Integer.toString(changedCount) + "...", 0);
					if (DetailGrid1SaveData(ix,"U")) {
						reload = true;
					}
				}
				tableContents.rowChanged[ix] = false;
			}
		}
		if (insertedCount > 0 || reload) {
			DetailGrid1LoadGrid(keys);
		}
	}

	//
	//  Delete any of the selected rows
	//
	public void DetailGrid1DeleteRows(String[] keys) {

		JDPTextGrid tableContents = DetailGrid1;

		if (keys == null || keys.length < 0) {
			DetailGrid1LoadEmptyGrid();
			return;
		}

		int deletedCount = 0;
		int cCount = 1;
		int iCount = 1;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				deletedCount++;
			} 
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				user.mainmsg.setStatusMsg("Deleting row " + Integer.toString(iCount++) + " of " + Integer.toString(deletedCount) + "...", 0);
				DetailGrid1SaveData(ix,"D");
			}
		}
		if (deletedCount > 0) {
			DetailGrid1LoadGrid(keys);
		}
	}

	//
	//  Save the selected item
	//
	boolean DetailGrid1SaveData(int tableRow, String action) {

		JDPTextGrid tableContents = DetailGrid1;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		String SQL = "";
		String prevSQL = null;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		if (action.equals("I")) {
			SQL = "INSERT INTO dbo_titles (title_id, " +
					"title, " +
					"price, " +
					"type, " +
					"pub_id, " +
					"advance, " +
					"royalty, " +
					"ytd_sales, " +
					"notes, " +
					"pubdate) VALUES('" + user.u.replace(tableContents.currentText[0][tableRow],"'","''") + "', " +
					"'" + (String)tableContents.pullDownValue[1][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[1][0],tableContents.currentText[1][tableRow])) + "', " +
					"" + JDPUtils.tonum(tableContents.currentText[2][tableRow]) + ", " +
					"'', " +
					"'', " +
					"0, " +
					"0, " +
					"0, " +
					"'', " +
					"'')";
		} else {
			if (action.equals("D")) {
				SQL = "DELETE FROM dbo_titles" +
					" WHERE title_id='" + tableContents.rowKey[tableRow][0] + "'" ;
				if (tableContents.recordLockValue[tableRow] != null) {
					prevSQL = SQL;
				}
			} else {
				SQL = "UPDATE dbo_titles SET title = '" + (String)tableContents.pullDownValue[1][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[1][0],tableContents.currentText[1][tableRow])) + "', " +
					"price = " + JDPUtils.tonum(tableContents.currentText[2][tableRow]) + "" +
					" WHERE title_id='" + tableContents.rowKey[tableRow][0] + "'" ;
				if (tableContents.recordLockValue[tableRow] != null) {
					prevSQL = SQL;
				}
			}
		}

		recCount = jaggSQL.execSQL(SQL, results);

		if (user.DEBUG) System.out.println("saveData CNT: "+Integer.toString(recCount));

		if (recCount == 0 && prevSQL != null) {
			String[] buttons = {"Reload","Update"};
			int[] icons = {JDPButton.UNDO,JDPButton.SAVE};
			JDPMessageDialog d = new JDPMessageDialog(user, user.jdpMainWindow, "Update failed...", "The record has been changed by another user...",buttons, icons);
			d.display();
			if (d.getPressedButton() == 1) {
				results = new Vector();
				recCount = jaggSQL.execSQL(prevSQL, results);
			} else {
				return true;
			}
		}

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return false;
		}
		if(recCount == 1) {
			if (action.equals("I")) {
				user.mainmsg.setStatusMsg("Record successfully added.",3);
			} else 
			if (action.equals("D")) {
				user.mainmsg.setStatusMsg("Record successfully removed.",3);
			} else {
				user.mainmsg.setStatusMsg("Record successfully updated.",3);
			}
		} else {
			user.u.setSqlMessage(jaggSQL,SQL);
		}
		if (prevSQL != null) {
			return true;
		}
		return false;

	}

	//
	//  Load the grid with the blank rows to allow data entry
	//
	public void DetailGrid1LoadEmptyGrid() {

		JDPTextGrid tableContents = DetailGrid1;
		int columnCount = 3;

		tableContents.currentText = new String[columnCount][50];
		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		tableContents.rowKey = new String[50][1];
		tableContents.newTable();
		tableContents.totalDataRows = 0;
	}

	//
	//  Set up the parameters for this grid
	//
	void DetailGrid1SetGridSettings() {

		if (DetailGrid1 == null) {
			DetailGrid1 = new JDPTextGrid(user);
		} 
		JDPTextGrid tableContents = DetailGrid1;
		int columnCount = 3;

		tableContents.columnHeader = new String[columnCount];
		tableContents.columnHeaderStyle = new int[columnCount];
		tableContents.columnStyle = new int[columnCount];
		tableContents.columnHeaderColor = new Color[columnCount];
		tableContents.columnColor = new Color[columnCount];
		tableContents.columnBGColor = new Color[columnCount];
		tableContents.columnProtected = new boolean[columnCount];
		tableContents.columnWidth = new int[columnCount];
		tableContents.rightJustify = new boolean[columnCount];
		tableContents.rowHeader = null;
		tableContents.columnHeight = null;
		for (int ix=0; ix<columnCount; ix++) {
			tableContents.columnHeaderStyle[ix] = Font.BOLD;
			tableContents.columnStyle[ix] = Font.PLAIN;
			tableContents.columnHeaderColor[ix] = Color.black;
			tableContents.columnColor[ix] = Color.black;
			tableContents.columnBGColor[ix] = Color.white;
			tableContents.columnStyle[ix] = Font.PLAIN;
		}
		tableContents.columnProtected[1] = true;
		tableContents.columnWidth[0] = 56;
		tableContents.columnWidth[1] = 358;
		tableContents.columnWidth[2] = 92;
		tableContents.rightJustify[2] = true;
		tableContents.columnHeader[0] = "Title Id";
		tableContents.columnHeader[1] = "Title";
		tableContents.columnHeader[2] = "Price";

		DetailGrid1LoadEmptyGrid();
		DetailGrid1LoadChoices();
	}

	//
	//  Load all of the Screen Choices
	//
	void DetailGrid1LoadChoices() {

		JDPTextGrid tableContents = DetailGrid1;
		int columnCount = 3;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		tableContents.isPullDownCol = new boolean[columnCount];
		tableContents.pullDownList = new List[columnCount][1];
		tableContents.isPullDownCol[1] = true;
		tableContents.pullDownList[1][0] = new List();

		tableContents.pullDownValue[1][0] = new Vector(); 
		new JDPLoadChoice(user,jaggSQL,tableContents.pullDownList[1][0],"title","title","dbo_titles","(1=1)",tableContents.pullDownValue[1][0]);
	}

	//
	//  New Method
	//
	public void DetailGrid1Method() {

		

	}
	String prevProdid = null;
	int prevTablerow = -1;
	//
	//  Fetch the price of the product selected
	//
	public void DetailGrid1FetchPrice() {

		JDPTextGrid tableContents = DetailGrid1;

		int tableRow = tableContents.getPrevRow();

		String prodid = tableContents.currentText[1][tableRow];

		if (prevProdid != null &&
		    prevProdid.equals(prodid) &&
		    tableRow == prevTablerow) return;

		prevProdid = prodid;
		prevTablerow = tableRow;

		StringTokenizer stok;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		int columnCount = 4;

		Vector columns = new Vector();
		Vector indexes = new Vector();

		String SQL = "SELECT price FROM dbo_titles WHERE title = '";
		SQL += prodid;
		SQL += "'";

		user.mainmsg.setStatusMsg("Accessing database...", 0);

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}

		if(recCount == 0) {
			return;
		}

		row = (String)results.elementAt(0);
		if ((row != null) && (row.trim().compareTo("") != 0)) {
			stok = new StringTokenizer(row);
			tableContents.currentText[2][tableRow] = stok.nextToken();
			JDPMaskEditMain.formatFloat(tableContents,2,tableRow,"$999,999,999,999.00");
		}

		user.mainmsg.clearStatusMsg();

	}

	
}

