//--------------------------------------------------------------------
//                                                                    
//  Module:       SampleQuery                                       
//  Description:  SampleQuery
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SampleQuery extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPButtons JDPButtons1;
	JDPJagg Database1;
	TextArea TextArea1;
	TextField TextField1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		CheckboxGroup cbGroup4 = new CheckboxGroup();
		Main = new Panel();
		String[] JDPButtons1btns = {"Get Data"};
		int[] JDPButtons1icns = {JDPButton.getIconValue("Report")};
		JDPButtons1 = new JDPButtons(user, JDPButtons1btns, JDPButtons1icns, JDPButtons.getAlignmentValue("Horizontal"));
		Database1 = new JDPJagg(user.jaggPath);
		TextArea1 = new TextArea("", 3,20);
		TextField1 = new TextField("", 20);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("South", JDPButtons1);
		Main.add("Center", TextArea1);
		Main.add("North", TextField1);

		TextField1.setText("SELECT stor_name FROM dbo_stores");


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(JDPButtons1.button[0])) {
				Database1.setDSN("JDP Tutorial");
				Database1.setCSTR("DSN=JDP Tutorial;");
				Vector results = new Vector();
				String SQL = TextField1.getText();
				
				//
				//  Send a message to the console
				//
				user.mainmsg.setStatusMsg("Accessing database...", 0);
				
				//
				//  Run the SQL and retrieve the results to a Vector
				//
				int recCount = Database1.execSQL(SQL, results);
				
				String OutputText = "";
				
				//
				//  Extract the results and put them in the TextArea
				//
				for (int ix=0; ix<recCount; ix++) {
					String row = (String)results.elementAt(ix);
					StringTokenizer stok = new StringTokenizer(row, Database1.getSEP());
					while (stok.hasMoreTokens()) {
						OutputText += stok.nextToken() + "\t";
					}
					OutputText += "\r\n";
				}
				
				TextArea1.setText(OutputText);
				
				//
				//  Send a message to the console
				//
				user.mainmsg.setStatusMsg(Integer.toString(recCount) + " records retrieved.", 5);
				
				
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}

}

