//--------------------------------------------------------------------
//                                                                    
//  Module:       SearchPanel                                       
//  Description:  SearchPanel
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SearchPanel extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	Panel Panel1;
	JDPSearchResults ResultList1;
	JDPWhereClause SearchPanel1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		CheckboxGroup cbGroup4 = new CheckboxGroup();
		Main = new Panel();
		Panel1 = new Panel();
		ResultList1Main();
		SearchPanel1Main();

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("West", Panel1);
		Panel1.setLayout(new BorderLayout());
		Panel1.add("Center", ResultList1);
		Panel1.add("North", SearchPanel1);



		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(SearchPanel1)) {
				ResultList1.clearList();
				ResultList1.setFromWhereClause(SearchPanel1.getFromWhereClause());
				ResultList1.loadList();
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		

	}
	//
	//  Create and load the Result List Panel
	//
	public void ResultList1Main() {

		String ResultList1sf = "stor_id";
		String[] ResultList1df = {};
		String ResultList1wc = "(1=1)";
		String[] ResultList1sct = {"Stor  name","Stor Address"};
		String[] ResultList1sc = {"stor_name","stor_address"};
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setCSTR("DSN=JDP Tutorial;UID=;PWD=;");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");
		ResultList1 = new JDPSearchResults(user, targetPanel, true, jaggSQL, false, ResultList1sf, ResultList1df, ResultList1wc, ResultList1sct, ResultList1sc, ResultList1sc, "", true, "Total Entries:");
		int[] ResultList1icons = new int[4];
		ResultList1icons[0] = 3;
		ResultList1icons[1] = 5;
		ResultList1.setMinWidth(130);
		ResultList1.setIcons(ResultList1icons);
		ResultList1.setFromWhereClause(" FROM dbo_stores WHERE (1=1)");
		ResultList1.clearList("");
		ResultList1.loadList();
	}

	//
	//  Create and load the Search Panel
	//
	public void SearchPanel1Main() {

		String[] SearchPanel1cf = new String[5];
		String[] SearchPanel1acf = new String[5];
		Vector SearchPanel1mu = new Vector();
		Vector SearchPanel1amu = new Vector();
		SearchPanel1cf[0] = "Store name";
		SearchPanel1acf[0] = "stor_name";
		SearchPanel1cf[1] = "Store Address";
		SearchPanel1acf[1] = "stor_address";
		SearchPanel1cf[2] = "City";
		SearchPanel1acf[2] = "city";
		SearchPanel1cf[3] = "State";
		SearchPanel1acf[3] = "state";
		SearchPanel1cf[4] = "Zip";
		SearchPanel1acf[4] = "zip";
		SearchPanel1mu.addElement(new Vector());
		SearchPanel1amu.addElement(new Vector());
		SearchPanel1mu.addElement(new Vector());
		SearchPanel1amu.addElement(new Vector());
		SearchPanel1mu.addElement(new Vector());
		SearchPanel1amu.addElement(new Vector());
		SearchPanel1mu.addElement(new Vector());
		SearchPanel1amu.addElement(new Vector());
		SearchPanel1mu.addElement(new Vector());
		SearchPanel1amu.addElement(new Vector());
		((Vector)SearchPanel1mu.elementAt(0)).addElement("Begins with");
		((Vector)SearchPanel1amu.elementAt(0)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(0)).addElement("Contains");
		((Vector)SearchPanel1amu.elementAt(0)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(1)).addElement("Begins with");
		((Vector)SearchPanel1amu.elementAt(1)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(1)).addElement("Contains");
		((Vector)SearchPanel1amu.elementAt(1)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(2)).addElement("Begins with");
		((Vector)SearchPanel1amu.elementAt(2)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(2)).addElement("Contains");
		((Vector)SearchPanel1amu.elementAt(2)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(3)).addElement("Begins with");
		((Vector)SearchPanel1amu.elementAt(3)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(3)).addElement("Contains");
		((Vector)SearchPanel1amu.elementAt(3)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(4)).addElement("Begins with");
		((Vector)SearchPanel1amu.elementAt(4)).addElement("like");
		((Vector)SearchPanel1mu.elementAt(4)).addElement("Contains");
		((Vector)SearchPanel1amu.elementAt(4)).addElement("like");
		int[] SearchPanel1cl = new int[5];
		boolean[] SearchPanel1cis = new boolean[5];
		SearchPanel1cl[0] = 8;
		SearchPanel1cis[0] = true;
		SearchPanel1cl[1] = 44;
		SearchPanel1cis[1] = true;
		SearchPanel1cl[2] = 44;
		SearchPanel1cis[2] = true;
		SearchPanel1cl[3] = 24;
		SearchPanel1cis[3] = true;
		SearchPanel1cl[4] = 6;
		SearchPanel1cis[4] = true;
		SearchPanel1 = new JDPWhereClause(user, targetPanel, "", true, "", SearchPanel1cf, SearchPanel1acf, SearchPanel1mu, SearchPanel1amu, null, null, SearchPanel1cl, SearchPanel1cis, "FROM dbo_stores WHERE (1=1)");
	}


}

