//--------------------------------------------------------------------
//                                                                    
//  Module:       EmployeeSummary                                       
//  Description:  EmployeeSummary
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class EmployeeSummary extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPChiselFramePanel ChiselPanel1;
	Panel Grid1;
	Panel Panel1;
	JDPWhereClause Grid1SP1;
	JDPTextGrid Grid1GL1;
	JDPButtons JDPButtons1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		ChiselPanel1 = new JDPChiselFramePanel(user, "Employee Summary");
		Grid1 = new Panel();
		Panel1 = new Panel();
				Grid1GL1 = new JDPTextGrid(user);
		String[] JDPButtons1btns = {"Apply","Refresh","Remove"};
		int[] JDPButtons1icns = {JDPButton.getIconValue("Save"),JDPButton.getIconValue("Undo"),JDPButton.getIconValue("Delete")};
		JDPButtons1 = new JDPButtons(user, JDPButtons1btns, JDPButtons1icns, JDPButtons.getAlignmentValue("Horizontal"));

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", ChiselPanel1);
		ChiselPanel1.add("Center", Grid1);
		Grid1.setLayout(new BorderLayout());
		Grid1Main();
		Grid1.add("Center", Panel1);
		Panel1.setLayout(new BorderLayout());
		Panel1.add("North", Grid1SP1);
		Panel1.add("Center", Grid1GL1);
		Panel1.add("South", JDPButtons1);

		Grid1SP1.setHorizontalLayout(true);


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(Grid1SP1)) {
				Grid1LoadGridFromWhereClause(Grid1SP1.getFromWhereClause());
				return true;
			}
			if (e.target.equals(JDPButtons1.button[0])) {
				Grid1UpdateRowsFromWhereClause(Grid1SP1.getFromWhereClause());
				return true;
			}
			if (e.target.equals(JDPButtons1.button[1])) {
				Grid1LoadGridFromWhereClause(Grid1SP1.getFromWhereClause());
				return true;
			}
			if (e.target.equals(JDPButtons1.button[2])) {
				Grid1DeleteRowsFromWhereClause(Grid1SP1.getFromWhereClause());
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		jaggSQL.setKeepConnectionOpen(false);

	}

	//
	//  Main initialization method
	//
	public void Grid1Main() {

		Grid1SetGridSettings();
		Grid1WhereClauseMain();
		Grid1SearchResultsMain();
//		Grid1LoadGrid(new String[0]);
	}





	//
	//  Load the grid with the specified parameters and selected data
	//
	public void Grid1LoadGridFromWhereClause(String whereClause) {

		int fPos = whereClause.indexOf("WHERE ");
		whereClause = " AND" + whereClause.substring(fPos+5);
		String[] keys = new String[0];

		Grid1LoadGridMain(keys, whereClause);
	}


	//
	//  Load the grid with the specified parameters and selected data
	//
	public void Grid1LoadGrid(String[] keys) {

		Grid1LoadGridMain(keys, null);
	}


	//
	//  Load the grid with the specified parameters and selected data
	//
	void Grid1LoadGridMain(String[] keys, String whereClause) {

		JDPTextGrid tableContents = Grid1GL1;

		StringTokenizer stok;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		int columnCount = 8;

		Vector columns = new Vector();
		Vector indexes = new Vector();

		String SQL = "SELECT emp_id, " +
					"emp_id, " +
					"fname, " +
					"minit, " +
					"lname, " +
					"job_id, " +
					"job_lvl, " +
					"pub_id, " +
					"hire_date FROM dbo_employee WHERE (1=1)  ";
		if (keys.length > 0 && keys[0] != null) SQL += " AND emp_id='" + keys[0]+ "'" ;
		if (whereClause != null) {
			SQL += whereClause;
		}

		user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}

		//
		//  Initialise result arrays
		//
		tableContents.totalDataRows = jaggSQL.getRowCount();
		actualRows = jaggSQL.getRowCount()+20;
		tableContents.currentText = new String[columnCount][actualRows];

		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		int keyCount = 1;
		tableContents.rowKey = new String[actualRows][keyCount];
		tableContents.recordLockValue = new String[actualRows];
		
		//
		//  Load key array and grid array
		//
		String tempText;
		for (int ix=0; ix<actualRows-20; ix++) {
			row = (String)results.elementAt(ix);
			if ((row != null) && (row.trim().compareTo("") != 0)) {
				stok = new StringTokenizer(row,sep);
				for (int iy=0; iy<keyCount; iy++) {
					tableContents.rowKey[ix][iy] = stok.nextToken().trim();
				}
				for (int iy=0; iy<columnCount; iy++) {
					tempText = stok.nextToken().trim();
					tableContents.currentText[iy][ix] = tempText;
					if ((iy == 4) && (tableContents.pullDownValue[4][0].indexOf(tempText) >= 0)) tableContents.currentText[iy][ix] = tableContents.pullDownList[4][0].getItem(tableContents.pullDownValue[4][0].indexOf(tempText));
					if ((iy == 6) && (tableContents.pullDownValue[6][0].indexOf(tempText) >= 0)) tableContents.currentText[iy][ix] = tableContents.pullDownList[6][0].getItem(tableContents.pullDownValue[6][0].indexOf(tempText));
					if (iy == 7) tableContents.currentText[iy][ix] = JDPDate.format(Long.valueOf(tempText).longValue());
				}
			}
		}
		for (int ix=actualRows-20; ix<actualRows; ix++) {
			for (int iy=0; iy<keys.length; iy++) {
				tableContents.rowKey[ix][iy] = keys[iy];
			}
		}

		tableContents.newTable();

		//
		//  Clear status message
		//
		user.mainmsg.clearStatusMsg();
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	public void Grid1UpdateRowsFromWhereClause(String whereClause) {

		int fPos = whereClause.indexOf("WHERE ");
		whereClause = " AND" + whereClause.substring(fPos+5);
		String[] keys = new String[0];

		Grid1UpdateRowsMain(keys, whereClause);
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	public void Grid1UpdateRows(String[] keys) {

		Grid1UpdateRowsMain(keys, null);
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	void Grid1UpdateRowsMain(String[] keys, String whereClause) {

		JDPTextGrid tableContents = Grid1GL1;

		int changedCount = 0;
		int insertedCount = 0;
		int cCount = 1;
		int iCount = 1;
		boolean reload = false;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					insertedCount++;
				} else {
					changedCount++;
				}
			}
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowChanged[ix]) {
				if (ix >= tableContents.totalDataRows) {
					user.mainmsg.setStatusMsg(JDPLang.get("Message7",iCount++,insertedCount), 0);
					Grid1SaveData(ix,"I");
				} else {
					user.mainmsg.setStatusMsg(JDPLang.get("Message8",cCount++,changedCount), 0);
					if (Grid1SaveData(ix,"U")) {
						reload = true;
					}
				}
				tableContents.rowChanged[ix] = false;
			}
		}
		if (insertedCount > 0 || reload) {
			Grid1LoadGridMain(keys, whereClause);
		}
	}


	//
	//  Delete any of the selected rows
	//
	public void Grid1DeleteRowsFromWhereClause(String whereClause) {

	int fPos = whereClause.indexOf("WHERE ");
		whereClause = " AND" + whereClause.substring(fPos+5);
		String[] keys = new String[0];

		Grid1DeleteRowsMain(keys, whereClause);
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	public void Grid1DeleteRows(String[] keys) {

		Grid1DeleteRowsMain(keys, null);
	}


	//
	//  Check each row that has changed and issue an update to the database
	//
	void Grid1DeleteRowsMain(String[] keys, String whereClause) {

		JDPTextGrid tableContents = Grid1GL1;

		int deletedCount = 0;
		int cCount = 1;
		int iCount = 1;
		
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				deletedCount++;
			} 
		}
		for (int ix=0; ix<tableContents.rowChanged.length; ix++) {
			if (tableContents.rowSelected[ix]) {
				user.mainmsg.setStatusMsg(JDPLang.get("Message9",iCount++,deletedCount), 0);
				Grid1SaveData(ix,"D");
			}
		}
		if (deletedCount > 0) {
			Grid1LoadGridMain(keys, whereClause);
		}
	}


	//
	//  Save the selected item
	//
	boolean Grid1SaveData(int tableRow, String action) {

		JDPTextGrid tableContents = Grid1GL1;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		String SQL = "";
		String prevSQL = null;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		if (action.equals("I")) {
			SQL = "INSERT INTO dbo_employee (emp_id, " +
					"fname, " +
					"minit, " +
					"lname, " +
					"job_id, " +
					"job_lvl, " +
					"pub_id, " +
					"hire_date) VALUES('" + user.u.replace(tableContents.currentText[0][tableRow],"'","''") + "', " +
					"'" + user.u.replace(tableContents.currentText[1][tableRow],"'","''") + "', " +
					"'" + user.u.replace(tableContents.currentText[2][tableRow],"'","''") + "', " +
					"'" + user.u.replace(tableContents.currentText[3][tableRow],"'","''") + "', " +
					"" + (String)tableContents.pullDownValue[4][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[4][0],tableContents.currentText[4][tableRow])) + ", " +
					"" + JDPUtils.tonum(tableContents.currentText[5][tableRow]) + ", " +
					"'" + (String)tableContents.pullDownValue[6][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[6][0],tableContents.currentText[6][tableRow])) + "', " +
					"'" + JDPDate.format(tableContents.currentText[7][tableRow]) + "')";
		} else {
			if (action.equals("D")) {
				SQL = "DELETE FROM dbo_employee" +
					" WHERE emp_id='" + tableContents.rowKey[tableRow][0]+ "'" ;
				if (tableContents.recordLockValue[tableRow] != null) {
					prevSQL = SQL;
				}
			} else {
				SQL = "UPDATE dbo_employee SET fname = '" + user.u.replace(tableContents.currentText[1][tableRow],"'","''") + "', " +
					"minit = '" + user.u.replace(tableContents.currentText[2][tableRow],"'","''") + "', " +
					"lname = '" + user.u.replace(tableContents.currentText[3][tableRow],"'","''") + "', " +
					"job_id = " + (String)tableContents.pullDownValue[4][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[4][0],tableContents.currentText[4][tableRow])) + ", " +
					"job_lvl = " + JDPUtils.tonum(tableContents.currentText[5][tableRow]) + ", " +
					"pub_id = '" + (String)tableContents.pullDownValue[6][0].elementAt(user.u.listIndexOf(tableContents.pullDownList[6][0],tableContents.currentText[6][tableRow])) + "', " +
					"hire_date = '" + JDPDate.format(tableContents.currentText[7][tableRow]) + "'" +
					" WHERE emp_id='" + tableContents.rowKey[tableRow][0]+ "'" ;
				if (tableContents.recordLockValue[tableRow] != null) {
					prevSQL = SQL;
				}
			}
		}

		recCount = jaggSQL.execSQL(SQL, results);

		if (user.DEBUG) System.out.println("saveData CNT: "+Integer.toString(recCount));

		if (recCount == 0 && prevSQL != null) {
			String[] buttons = {JDPLang.get("Reload"),JDPLang.get("Update")};
			int[] icons = {JDPButton.UNDO,JDPButton.SAVE};
			JDPMessageDialog d = new JDPMessageDialog(user, user.jdpMainWindow, JDPLang.get("Dialog0"), JDPLang.get("Dialog1"), buttons, icons);
			d.display();
			if (d.getPressedButton() == 1) {
				results = new Vector();
				recCount = jaggSQL.execSQL(prevSQL, results);
			} else {
				return true;
			}
		}

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return false;
		}
		if(recCount == 1) {
			if (action.equals("I")) {
				user.mainmsg.setStatusMsg(JDPLang.get("Message4"),3);
			} else 
			if (action.equals("D")) {
				user.mainmsg.setStatusMsg(JDPLang.get("Message5"),3);
			} else {
				user.mainmsg.setStatusMsg(JDPLang.get("Message6"),3);
			}
		} else {
			user.u.setSqlMessage(jaggSQL,SQL);
		}
		if (prevSQL != null) {
			return true;
		}
		return false;

	}


	//
	//  Load the grid with the blank rows to allow data entry
	//
	public void Grid1LoadEmptyGrid() {

		JDPTextGrid tableContents = Grid1GL1;
		int columnCount = 8;

		tableContents.currentText = new String[columnCount][50];
		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		tableContents.rowKey = new String[50][1];
		tableContents.newTable();
		tableContents.totalDataRows = 0;
	}


	//
	//  Set up the parameters for this grid
	//
	void Grid1SetGridSettings() {

		if (Grid1 == null) {
			Grid1 = new JDPTextGrid(user);
		} 
		JDPTextGrid tableContents = Grid1GL1;
		int columnCount = 8;

		tableContents.columnHeader = new String[columnCount];
		tableContents.columnHeaderStyle = new int[columnCount];
		tableContents.columnStyle = new int[columnCount];
		tableContents.columnHeaderColor = new Color[columnCount];
		tableContents.columnColor = new Color[columnCount];
		tableContents.columnBGColor = new Color[columnCount];
		tableContents.columnProtected = new boolean[columnCount];
		tableContents.columnWidth = new int[columnCount];
		tableContents.rightJustify = new boolean[columnCount];
		tableContents.rowHeader = null;
		tableContents.columnHeight = null;
		for (int ix=0; ix<columnCount; ix++) {
			tableContents.columnHeaderStyle[ix] = Font.BOLD;
			tableContents.columnStyle[ix] = Font.PLAIN;
			tableContents.columnHeaderColor[ix] = Color.black;
			tableContents.columnColor[ix] = Color.black;
			tableContents.columnBGColor[ix] = Color.white;
			tableContents.columnStyle[ix] = Font.PLAIN;
		}
		tableContents.columnProtected[4] = true;
		tableContents.columnProtected[6] = true;
		tableContents.columnWidth[0] = 78;
		tableContents.columnWidth[1] = 71;
		tableContents.columnWidth[2] = 36;
		tableContents.columnWidth[3] = 75;
		tableContents.columnWidth[4] = 175;
		tableContents.columnWidth[5] = 57;
		tableContents.columnWidth[6] = 119;
		tableContents.columnWidth[7] = 69;
		tableContents.rightJustify[5] = true;
		tableContents.columnHeader[0] = "Employee ID";
		tableContents.columnHeader[1] = "First Name";
		tableContents.columnHeader[2] = "Initial";
		tableContents.columnHeader[3] = "Last Name";
		tableContents.columnHeader[4] = "Job Description";
		tableContents.columnHeader[5] = "Job Level";
		tableContents.columnHeader[6] = "Publisher";
		tableContents.columnHeader[7] = "Hire Date";

		Grid1LoadEmptyGrid();
		Grid1LoadChoices();
	}


	//
	//  Load all of the Screen Choices
	//
	void Grid1LoadChoices() {

		JDPTextGrid tableContents = Grid1GL1;
		int columnCount = 8;

		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");

		tableContents.isPullDownCol = new boolean[columnCount];
		tableContents.pullDownColType = new int[columnCount];
		tableContents.pullDownList = new List[columnCount][1];
		tableContents.isPullDownCol[4] = true;
		tableContents.isPullDownCol[6] = true;
		tableContents.pullDownColType[4] = JDPTextGrid.REGULAR;
		tableContents.pullDownColType[6] = JDPTextGrid.REGULAR;
		tableContents.pullDownList[4][0] = new List();
		tableContents.pullDownList[6][0] = new List();
		tableContents.isPullDownCol[7] = true;
		tableContents.pullDownColType[7] = JDPTextGrid.DATE;

		tableContents.pullDownValue[4][0] = new Vector(); 
		new JDPLoadChoice(user,jaggSQL,tableContents.pullDownList[4][0],"job_desc","job_id","dbo_jobs","(1=1)",tableContents.pullDownValue[4][0]);

		tableContents.pullDownValue[6][0] = new Vector(); 
		new JDPLoadChoice(user,jaggSQL,tableContents.pullDownList[6][0],"pub_name","pub_id","dbo_publishers","(1=1)",tableContents.pullDownValue[6][0]);
	}


	//
	//  Create and load the Search Panel
	//
	public void Grid1WhereClauseMain() {

		String[] Grid1cf = new String[4];
		String[] Grid1acf = new String[4];
		Vector Grid1mu = new Vector();
		Vector Grid1amu = new Vector();
		Grid1cf[0] = "First Name";
		Grid1acf[0] = "fname";
		Grid1cf[1] = "Last Name";
		Grid1acf[1] = "lname";
		Grid1cf[2] = "Job Description";
		Grid1acf[2] = "job_id";
		Grid1cf[3] = "Publisher";
		Grid1acf[3] = "pub_id";
		Grid1mu.addElement(new Vector());
		Grid1amu.addElement(new Vector());
		Grid1mu.addElement(new Vector());
		Grid1amu.addElement(new Vector());
		Grid1mu.addElement(new Vector());
		Grid1amu.addElement(new Vector());
		Grid1mu.addElement(new Vector());
		Grid1amu.addElement(new Vector());
		((Vector)Grid1mu.elementAt(0)).addElement("Begins with");
		((Vector)Grid1amu.elementAt(0)).addElement("like");
		((Vector)Grid1mu.elementAt(0)).addElement("Contains");
		((Vector)Grid1amu.elementAt(0)).addElement("like");
		((Vector)Grid1mu.elementAt(1)).addElement("Begins with");
		((Vector)Grid1amu.elementAt(1)).addElement("like");
		((Vector)Grid1mu.elementAt(1)).addElement("Contains");
		((Vector)Grid1amu.elementAt(1)).addElement("like");
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");
		JDPLoadChoice lc = new JDPLoadChoice(user,jaggSQL,null,"","","","",-1);
		lc.loadChoice((Vector)Grid1mu.elementAt(2), "job_desc" ,"job_id" ,"dbo_jobs" ,"(1=1)" ,(Vector)Grid1amu.elementAt(2),4);
		lc.loadChoice((Vector)Grid1mu.elementAt(3), "pub_name" ,"pub_id" ,"dbo_publishers" ,"(1=1)" ,(Vector)Grid1amu.elementAt(3),12);
		int[] Grid1cl = new int[4];
		boolean[] Grid1cis = new boolean[4];
		Grid1cl[0] = 22;
		Grid1cis[0] = true;
		Grid1cl[1] = 32;
		Grid1cis[1] = true;
		Grid1cl[2] = 0;
		Grid1cis[2] = false;
		Grid1cl[3] = 0;
		Grid1cis[3] = true;
		Grid1SP1 = new JDPWhereClause(user, targetPanel, "", true, "Job Description", Grid1cf, Grid1acf, Grid1mu, Grid1amu, null, null, Grid1cl, Grid1cis, "FROM dbo_employee WHERE (1=1)");
		Grid1SP1.setDSNType("ACCESS");
		Grid1SP1.setDataType(0,12);
		Grid1SP1.setDataType(1,12);
		Grid1SP1.setDataType(2,5);
		Grid1SP1.setDataType(3,12);
	}


	//
	//  Create and load the Result List Panel
	//
	public void Grid1SearchResultsMain() {

	}



}

