//--------------------------------------------------------------------
//                                                                    
//  Module:       SalesSummaryReport                                       
//  Description:  SalesSummaryReport
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SalesSummaryReport extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPChiselFramePanel ChiselPanel1;
	Panel Report1;
	Panel Panel1;
	JDPWhereClause Report1SP1;
	JDPTextGrid Report1GL1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		ChiselPanel1 = new JDPChiselFramePanel(user, "Sales Summary Report");
		Report1 = new Panel();
		Panel1 = new Panel();
				Report1GL1 = new JDPTextGrid(user);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", ChiselPanel1);
		ChiselPanel1.add("Center", Report1);
		Report1.setLayout(new BorderLayout());
		Report1Main();
		Report1.add("Center", Panel1);
		Panel1.setLayout(new BorderLayout());
		Panel1.add("North", Report1SP1);
		Panel1.add("Center", Report1GL1);

		Report1SP1.setHorizontalLayout(true);


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(Report1SP1)) {
				Report1LoadGridFromWhereClause(Report1SP1.getFromWhereClause());
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		jaggSQL.setKeepConnectionOpen(false);

	}

	//
	//  Main initialization method
	//
	public void Report1Main() {

		Report1SetGridSettings();
		Report1WhereClauseMain();
		Report1SearchResultsMain();
//		Report1LoadGrid(null);

	}


	//
	//  Load the grid with the specified parameters and selected data
	//
	public void Report1LoadGridFromWhereClause(String whereClause) {

		int fPos = whereClause.indexOf("WHERE ");
		whereClause = " AND" + whereClause.substring(fPos+5);
		String[] keys = new String[0];

		Report1LoadGridMain(keys, whereClause);
	}


	//
	//  Load the grid with the specified parameters and selected data
	//
	public void Report1LoadGrid(String[] keys) {

		Report1LoadGridMain(keys, null);
	}


	//
	//  Load the grid with the specified parameters and selected data
	//
	void Report1LoadGridMain(String[] keys, String whereClause) {

		JDPTextGrid tableContents = Report1GL1;

		StringTokenizer stok;
		int recCount = 0;
		Vector results = new Vector();
		String sep = jaggSQL.getSEP();
		int actualRows = 0;
		String row;
		double[][] worksubTotal;
		double[][] workgrandTotal;
		int columnCount = 5;
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");


		Vector columns = new Vector();
		Vector indexes = new Vector();

		String SQL = "SELECT b.stor_name, " +
					"a.ord_num, " +
					"a.ord_date, " +
					"a.title_id, " +
					"a.qty FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id} WHERE (1=1)  ";
		if (keys.length > 0 && keys[0] != null) SQL += " AND a.stor_id='" + keys[0]+ "'" ;
		if (keys.length > 1 && keys[1] != null) SQL += " AND a.ord_num='" + keys[1]+ "'" ;
		if (keys.length > 2 && keys[2] != null) SQL += " AND a.title_id='" + keys[2]+ "'" ; 
		if (whereClause != null) {
			SQL += whereClause;
		}; 
		SQL+=" ORDER BY b.stor_name,a.ord_num";

		user.mainmsg.setStatusMsg(JDPLang.get("Message0"), 0);

		recCount = jaggSQL.execSQL(SQL, results);

		if(recCount == -1) {
			user.u.setSqlMessage(jaggSQL,SQL);
			return;
		}

		//
		//  Initialise result arrays
		//
		actualRows = jaggSQL.getRowCount();
		tableContents.currentText = new String[columnCount][actualRows*3+20];
		tableContents.cellFont = new Font[columnCount][actualRows*3+20];
		tableContents.gridColor = Color.white;
		boolean[] totalThisColumn = new boolean[columnCount];
		
		String[] lastItem = new String[columnCount];
		boolean[] subTotal = new boolean[5];
		boolean[] grandTotal = new boolean[5];
		int orderBy = 2;
		subTotal[1] = true;
		grandTotal[0] = true;
		totalThisColumn[4] = true;
		//
		//  Load arrays and result List
		//
		worksubTotal = new double[1][1];
		workgrandTotal = new double[1][1];
		int xOffset = 0;
		int	xIncrement = 0;
		int titlePos = (int)(columnCount/2)-1;
		if (titlePos < 0) titlePos = 0;
		tableContents.currentText[titlePos][1] = "Sales Summary Report";
		tableContents.cellFont[titlePos][1] = new Font(user.plainFont.getName(),Font.BOLD,user.plainFont.getSize()+4);
		for (int iy=0; iy<columnCount; iy++) {
			tableContents.cellFont[iy][3] = user.boldFont;
		}
		tableContents.currentText[0][3] = "Store name";
		tableContents.currentText[1][3] = "Order Number";
		tableContents.currentText[2][3] = "Order Date";
		tableContents.currentText[3][3] = "Title Id";
		tableContents.currentText[4][3] = "Quantity";
		xOffset = 4;
		worksubTotal = new double[orderBy][columnCount];
		workgrandTotal = new double[orderBy][columnCount];
		int ix;
		String tempText;
		for (ix=0; ix<actualRows; ix++) {
			row = (String)results.elementAt(ix);
			if ((row != null) && (row.trim().compareTo("") != 0)) {
				stok = new StringTokenizer(row,sep);
				for (int iy=0; iy<columnCount; iy++) {
					tempText = stok.nextToken().trim();
					tableContents.currentText[iy][ix+xOffset] = tempText;
					if (iy == 2) tableContents.currentText[iy][ix+xOffset] = JDPDate.format(Long.valueOf(tempText).longValue());
					if (tableContents.maskEdit[iy] != null) {
						if (tableContents.maskType[iy] == "Float") {
							tableContents.currentText[iy][ix+xOffset] = JDPMaskEditMain.formatFloat(tableContents.currentText[iy][ix+xOffset],tableContents.maskEdit[iy]);
						} else {
							tableContents.currentText[iy][ix+xOffset] = JDPMaskEditMain.formatString(tableContents.currentText[iy][ix+xOffset],tableContents.maskEdit[iy]);
						}
					}
				}
				for (int iy=columnCount-1; iy>=0; iy--) {
					String thisItem = tableContents.currentText[iy][ix+xOffset];
					if ((orderBy > iy) && (ix > 0)) {
						if (thisItem.equals(lastItem[iy])) {
							tableContents.currentText[iy][ix+xOffset] = "";
						} else {
							if (subTotal[iy]) {
								for (int iz=0; iz<columnCount; iz++) {
									tableContents.currentText[iz][ix+xOffset+1] = tableContents.currentText[iz][ix+xOffset];
									tableContents.currentText[iz][ix+xOffset] = "";
									tableContents.cellFont[iz][ix+xOffset+1] = tableContents.cellFont[iz][ix+xOffset];
									tableContents.cellFont[iz][ix+xOffset] = null;
								}
								tableContents.currentText[iy][ix+xOffset] = JDPLang.get("Report0");
								tableContents.cellFont[iy][ix+xOffset] = user.boldFont;
								for (int iw=iy+1; iw<columnCount; iw++) {
									if (totalThisColumn[iw]) {
										tableContents.currentText[iw][ix+xOffset] = JDPMaskEditMain.formatFloat(worksubTotal[iy][iw],tableContents.maskEdit[iw]);
										tableContents.cellFont[iw][ix+xOffset] = user.boldFont;
									}
									worksubTotal[iy][iw] = 0;
								}
								xOffset += 1;
							}
							tableContents.currentText[iy][ix+xOffset] = thisItem;
						}
					}
					if ((orderBy > 0) && (ix > 0)) {
						try {
							double tempfloat = Double.valueOf(JDPMaskEditMain.stripFloat(lastItem[iy])).doubleValue();
							for (int iz=0; iz<orderBy; iz++) {
								worksubTotal[iz][iy] += tempfloat;
								workgrandTotal[iz][iy] += tempfloat;
							}
						} catch(Exception e) { 
						}
					}
					lastItem[iy] = thisItem;
				}
			}
		}

		for (int iy=0; iy<columnCount; iy++) {
			try {
				double tempfloat = Double.valueOf(JDPMaskEditMain.stripFloat(lastItem[iy])).doubleValue();
				for (int iz=0; iz<orderBy; iz++) {
					worksubTotal[iz][iy] += tempfloat;
					workgrandTotal[iz][iy] += tempfloat;
				}
			} catch(Exception e) { 
			}
		}
		for (int iy=columnCount-1; iy>=0; iy--) {
			if (orderBy > iy) {
				if (subTotal[iy]) {
					tableContents.currentText[iy][ix+xOffset] = JDPLang.get("Report0");
					tableContents.cellFont[iy][ix+xOffset] = user.boldFont;
					for (int iw=iy+1; iw<columnCount; iw++) {
						if (totalThisColumn[iw]) {
							tableContents.currentText[iw][ix+xOffset] = JDPMaskEditMain.formatFloat(worksubTotal[iy][iw],tableContents.maskEdit[iw]);
							tableContents.cellFont[iw][ix+xOffset] = user.boldFont;
						}
					}
					xOffset += 1;
				}
			}
		}
		for (int iy=columnCount-1; iy>=0; iy--) {
			if (orderBy > iy) {
				if (grandTotal[iy]) {
					tableContents.currentText[iy][ix+xOffset] = JDPLang.get("Report1");
					tableContents.cellFont[iy][ix+xOffset] = user.boldFont;
					for (int iw=iy+1; iw<columnCount; iw++) {
						if (totalThisColumn[iw]) {
							tableContents.currentText[iw][ix+xOffset] = JDPMaskEditMain.formatFloat(workgrandTotal[iy][iw],tableContents.maskEdit[iw]);
							tableContents.cellFont[iw][ix+xOffset] = user.boldFont;
						}
					}
					xOffset++;
				}
			}
		}

		tableContents.newTable();

		//
		//  Clear status message
		//
		user.mainmsg.clearStatusMsg();
	}


	//
	//  Load the grid with the blank rows to allow data entry
	//
	public void Report1LoadEmptyGrid() {

		JDPTextGrid tableContents = Report1GL1;
		int columnCount = 5;

		tableContents.currentText = new String[columnCount][50];
		tableContents.cellChanged = null;
		tableContents.rowChanged = null;
		tableContents.columnSelected = null;
		tableContents.rowKey = new String[50][1];
		tableContents.newTable();
		tableContents.totalDataRows = 0;
	}


	//
	//  Set up the parameters for this grid
	//
	void Report1SetGridSettings() {

		if (Report1 == null) {
			Report1 = new JDPTextGrid(user);
		} 
		JDPTextGrid tableContents = Report1GL1;
		int columnCount = 5;

		tableContents.columnHeader = null;
		tableContents.columnHeaderStyle = new int[columnCount];
		tableContents.columnStyle = new int[columnCount];
		tableContents.columnHeaderColor = new Color[columnCount];
		tableContents.columnColor = new Color[columnCount];
		tableContents.columnBGColor = new Color[columnCount];
		tableContents.gridColor = Color.white;
		tableContents.columnProtected = new boolean[columnCount];
		tableContents.columnWidth = new int[columnCount];
		tableContents.rightJustify = new boolean[columnCount];
		tableContents.rowHeader = null;
		tableContents.columnHeight = null;
		tableContents.maskEdit = new String[columnCount];
		tableContents.maskType = new String[columnCount];
		for (int ix=0; ix<columnCount; ix++) {
			tableContents.columnHeaderStyle[ix] = Font.BOLD;
			tableContents.columnStyle[ix] = Font.PLAIN;
			tableContents.columnHeaderColor[ix] = Color.black;
			tableContents.columnColor[ix] = Color.black;
			tableContents.columnBGColor[ix] = Color.white;
			tableContents.columnStyle[ix] = Font.PLAIN;
		}
		tableContents.columnProtected[0] = true;
		tableContents.columnProtected[1] = true;
		tableContents.columnProtected[2] = true;
		tableContents.columnProtected[3] = true;
		tableContents.columnProtected[4] = true;
		tableContents.columnWidth[0] = 205;
		tableContents.columnWidth[1] = 88;
		tableContents.columnWidth[2] = 133;
		tableContents.columnWidth[3] = 56;
		tableContents.columnWidth[4] = 72;
		tableContents.rightJustify[4] = true;
		tableContents.maskEdit[4] = "999,999,999,999";
		tableContents.maskType[4] = "Float";
		
		Report1LoadEmptyGrid();
	}


	//
	//  Create and load the Search Panel
	//
	public void Report1WhereClauseMain() {

		String[] Report1cf = new String[2];
		String[] Report1acf = new String[2];
		Vector Report1mu = new Vector();
		Vector Report1amu = new Vector();
		Report1cf[0] = "Order Date";
		Report1acf[0] = "format(a.ord_date, 'yyyy/mm/dd')";
		Report1cf[1] = "Store Name";
		Report1acf[1] = "b.stor_id";
		Report1mu.addElement(new Vector());
		Report1amu.addElement(new Vector());
		Report1mu.addElement(new Vector());
		Report1amu.addElement(new Vector());
		((Vector)Report1mu.elementAt(0)).addElement("Equal to");
		((Vector)Report1amu.elementAt(0)).addElement("=");
		((Vector)Report1mu.elementAt(0)).addElement("Greater than");
		((Vector)Report1amu.elementAt(0)).addElement(">");
		((Vector)Report1mu.elementAt(0)).addElement("Less than");
		((Vector)Report1amu.elementAt(0)).addElement("<");
		jaggSQL.setDSN("JDP Tutorial");
		jaggSQL.setUID("");
		jaggSQL.setPWD("");
		jaggSQL.setMRW("1000");
		jaggSQL.setTOUT("60");
		JDPLoadChoice lc = new JDPLoadChoice(user,jaggSQL,null,"","","","",-1);
		lc.loadChoice((Vector)Report1mu.elementAt(1), "stor_name" ,"stor_id" ,"dbo_stores" ,"(1=1)" ,(Vector)Report1amu.elementAt(1),12);
		int[] Report1cl = new int[2];
		boolean[] Report1cis = new boolean[2];
		Report1cl[0] = 21;
		Report1cis[0] = true;
		Report1cl[1] = 0;
		Report1cis[1] = true;
		Report1SP1 = new JDPWhereClause(user, targetPanel, "", true, "Store Name", Report1cf, Report1acf, Report1mu, Report1amu, null, null, Report1cl, Report1cis, "FROM {oj dbo_sales a LEFT OUTER JOIN dbo_stores b ON a.stor_id = b.stor_id} WHERE (1=1)");
		Report1SP1.setDSNType("ACCESS");
		Report1SP1.setDataType(0,11);
		Report1SP1.setDataType(1,12);
	}


	//
	//  Create and load the Result List Panel
	//
	public void Report1SearchResultsMain() {

	}



}

