//--------------------------------------------------------------------
//                                                                    
//  Module:       SalesReportClient                                       
//  Description:  SalesReportClient
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SalesReportClient extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPScrollPanel ScrollPanel1;
	Label Label2;
	TextField mailServer;
	Label Label3;
	TextField toAddress;
	Label Label4;
	TextField returnAddress;
	Label Label1;
	JDPButtons JDPButtons1;
	JDPRMIConnection RMIConnection1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		this.targetPanel = targetPanel;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		ScrollPanel1 = new JDPScrollPanel();
		Label2 = new Label("Mail Server Name:", Label.LEFT);
		mailServer = new TextField("mail", 20);
		Label3 = new Label("Recipient Email Address:", Label.LEFT);
		toAddress = new TextField("", 20);
		Label4 = new Label("Sender's Email Address:", Label.LEFT);
		returnAddress = new TextField("", 20);
		Label1 = new Label("This example demonstrates the use of a Server Session Bean that sends a email sales report to an end user", Label.LEFT);
		String[] JDPButtons1btns = {"Send"};
		int[] JDPButtons1icns = {JDPButton.getIconValue("Email")};
		JDPButtons1 = new JDPButtons(user, JDPButtons1btns, JDPButtons1icns, JDPButtons.getAlignmentValue("Horizontal"));
		RMIConnection1 = new JDPRMIConnection(user);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", ScrollPanel1);
		ScrollPanel1.add("Left", Label2);
		ScrollPanel1.add("Right", mailServer);
		ScrollPanel1.add("Left", Label3);
		ScrollPanel1.add("Right", toAddress);
		ScrollPanel1.add("Left", Label4);
		ScrollPanel1.add("Right", returnAddress);
		Main.add("North", Label1);
		Main.add("South", JDPButtons1);



		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
		//
		//  Initialise Components
		//
		InitComponents();
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(JDPButtons1.button[0])) {
				submitReportJob();
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	/**
	 * Initialise other components by calling their methods
	 */
	public void InitComponents() {

		jaggSQL.setKeepConnectionOpen(false);

	}

	/**
	 * Submit the report job to run on the server
	 */
	public void submitReportJob() {

		/**
		 * Submit a job to run on the server.
		 * @param jobQueue the queue to which the job is submitted.
		 * @param jobName the name to give this job.
		 * @param objectType the type of object to run (C-Java Class, A-Application, J-Job Stream).
		 * @param objectName the name of the class, application or job stream.
		 * @param objectConstructor the constructor to use for creating the Java class (eg "(JDPSubsystemMgr,JDPJob)"),
		 * @param objectParameters the parameters for this Java class or Application.
		 * @param jobExecutionPriority a priority in the range 1-10. 5 is default.
		 * @param jobQueuePriority a priority in the range 1-10. 5 is default.
		 * @param jobHeld true if job should be held on the job queue.
		 * @param notifyUser the userid of the user to notify upon completion (-1 for no notification).
		 * @param notifyVia notify via (E-Email, P-Pager, B-Both).
		 * @param nofifyOn notify on (S-Success, F-Failure, B-Both).
		 * @param logEvent log event on (N-No logging, S-Success, F-Failure, B-Both).
		 * @return either null if the job was submitted or a message telling why it was not submitted.
		 */

		String parameters = "JDPSubsystemMgr,JDPJob,";
		parameters += mailServer.getText()+",";
		parameters += toAddress.getText()+",";
		parameters += returnAddress.getText();
		
		String result = RMIConnection1.submitJob("QIMMED", "Sales Report", "C", "SalesReportSessionBean", "(JDPSubsystemMgr,JDPJob,String,String,String)", 
				parameters, 5, 5, false, -1, "", "", "B");
		if (result == null) {
			user.mainmsg.setStatusMsg("Job submission failed.",10);
		} else 
		if (result.startsWith("Jobnumber:")) {
			user.mainmsg.setStatusMsg("Sales Report job submitted to QIMMED.",10);
		} else {
			user.mainmsg.setStatusMsg(result,20);
		}
	

	}


}

