//--------------------------------------------------------------------
//                                                                    
//  Module:       SimpleServerPush                                       
//  Description:  SimpleServerPush
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SimpleServerPush extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	Label Label1;
	Panel Panel1;
	Panel Panel2;
	List connectedClients;
	JDPButton JDPButton1;
	Panel Panel3;
	JDPScrollPanel ScrollPanel1;
	JDPButton JDPButton2;
	JDPButton JDPButton3;
	JDPScrollPanel ScrollPanel2;
	Label Label2;
	TextField requestData;
	Label Label3;
	TextField dataReceived;
	JDPServerSender MessageSender1;
	JDPServerListener MessageReceiver1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		this.targetPanel = targetPanel;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		Label1 = new Label("This example demostrates using server push to send a message to a JDP client", Label.LEFT);
		Panel1 = new Panel();
		Panel2 = new Panel();
		connectedClients = new List();
		JDPButton1 = new JDPButton("Get Connected Clients", JDPButton.getIconValue("Custom"), JDPButton.getAlignmentValue("Center"));
		Panel3 = new Panel();
		ScrollPanel1 = new JDPScrollPanel();
		JDPButton2 = new JDPButton("Press to register to receive requests of type 'TestRequest'", JDPButton.getAlignmentValue("Center"));
		JDPButton3 = new JDPButton("Press so send a request of type 'TestRequest' to the selected IP address", JDPButton.getAlignmentValue("Center"));
		ScrollPanel2 = new JDPScrollPanel();
		Label2 = new Label("Data to send:", Label.LEFT);
		requestData = new TextField("sample data", 20);
		Label3 = new Label("Data received:", Label.LEFT);
		dataReceived = new TextField("", 20);
		MessageSender1 = new JDPServerSender(user);
		MessageReceiver1 = user.serverListener;

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("North", Label1);
		Main.add("Center", Panel1);
		Panel1.setLayout(new BorderLayout());
		Panel1.add("West", Panel2);
		Panel2.setLayout(new BorderLayout());
		Panel2.add("Center", connectedClients);
		Panel2.add("North", JDPButton1);
		Panel1.add("Center", Panel3);
		Panel3.setLayout(new BorderLayout());
		Panel3.add("North", ScrollPanel1);
		ScrollPanel1.add("Left", JDPButton2);
		ScrollPanel1.add("Left", JDPButton3);
		Panel3.add("Center", ScrollPanel2);
		ScrollPanel2.add("Left", Label2);
		ScrollPanel2.add("Right", requestData);
		ScrollPanel2.add("Left", Label3);
		ScrollPanel2.add("Right", dataReceived);



		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
		//
		//  Initialise Components
		//
		InitComponents();
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(JDPButton1)) {
				connectedClients.clear();
				MessageSender1.getConnectedClients();
				String[] addresses = MessageSender1.getIPAddresses();
				if (addresses != null) {
					for (int ix=0; ix<addresses.length; ix++) {
						connectedClients.addItem(addresses[ix]);
					}
				}
				return true;
			}
			if (e.target.equals(JDPButton2)) {
				MessageReceiver1.registerForRequest("TestRequest", this);
				user.mainmsg.setStatusMsg("Registration complete", 10);
				return true;
			}
			if (e.target.equals(JDPButton3)) {
				if (connectedClients.getSelectedIndex() >= 0) {
					Event thisEvent = new Event(this,Event.ACTION_EVENT,requestData.getText());
					if (MessageSender1.sendEventToClient(connectedClients.getSelectedItem(), "TestRequest", thisEvent)) {
						user.mainmsg.setStatusMsg("Request sent",10);
					} else {
						user.mainmsg.setStatusMsg("Could not send requested to selected IP address",15);
					}
				}
				return true;
			}
			if (e.target.equals(MessageReceiver1)) {
				if (e.arg instanceof String) {
					String data = (String)e.arg;
					if (data.startsWith("TestRequest")) {
						data = data.substring(data.indexOf("|")+1);
						dataReceived.setText(data);
					}
				}
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		jaggSQL.setKeepConnectionOpen(false);

	}


}

