//--------------------------------------------------------------------
//                                                                    
//  Module:       TestTrigger                                       
//  Description:  TestTrigger
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class TestTrigger extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPScrollPanel ScrollPanel1;
	Label Label1;
	JDPButton JDPButton1;
	JDPRMIConnection RMIConnection1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		this.targetPanel = targetPanel;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		ScrollPanel1 = new JDPScrollPanel();
		Label1 = new Label("Press to trigger the Test Event", Label.LEFT);
		JDPButton1 = new JDPButton("Trigger", JDPButton.getIconValue("Arrow"), JDPButton.getAlignmentValue("Center"));
		RMIConnection1 = new JDPRMIConnection(user);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", ScrollPanel1);
		ScrollPanel1.add("Left", Label1);
		ScrollPanel1.add("Right", JDPButton1);



		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
		//
		//  Initialise Components
		//
		InitComponents();
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.ACTION_EVENT:
			if (e.target.equals(JDPButton1)) {
				RMIConnection1.triggerEvent("01001", "Test Triggered");
				user.mainmsg.setStatusMsg("\"Test Triggered\" event fired. Check Enterprise Server to see that job is queued or started.",10);
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	/**
	 * Initialise other components by calling their methods
	 */
	public void InitComponents() {

		jaggSQL.setKeepConnectionOpen(false);

	}


}

